/**
 * Created by kinfen on 16/8/5.
 */
import path from 'path';

var controlAPI = function(opt, isNeedCsrfVaild, cb)
{
	if (isNeedCsrfVaild)
	{
		var key = "x-csrf-token";
		opt.beforeSend=function(req) {
			req.setRequestHeader(key, KAdm.csrf.header[key]);
		};
		//opt.data[KAdm.csrf.key] = KAdm.csrf.value;
	}
	if (!opt.success && !opt.error){
		if (cb){
			opt.success = (data)=>{
				cb(null, data);
			}
			opt.error = (xhr, error)=>{
				cb(xhr.responseJSON, null);
			}
		}
	}
	$.ajax(opt);
}

export const APP_SIDE_BAR_LOADED = "APP_SIDE_BAR_LOADED";
export function updateModulesTree (modules) {
	return {
		type: APP_SIDE_BAR_LOADED,
		modules,
	};
}

export const APP_MODULE_SELECTED = "APP_MODULE_SELECTED";
export function selecteModule (selectedModule) {
	return {
		type: APP_MODULE_SELECTED,
		selectedModule,
	};
}

export const APP_SHOW_MAIN_LOADING = "APP_SHOW_MAIN_LOADING";
export function showLoading (bool) {
	return {
		type: APP_SHOW_MAIN_LOADING,
		mainloading:bool,
	};
}

export const APP_LOAD_CURRENT_USER = "APP_LOAD_CURRENT_USER";
export function loadCurrentUser () {
	return (dispatch, getState) => {
		let url = path.join(KAdm.adminPath, 'api2', 'User', KAdm.user.id);
		controlAPI({
			url,
			data:{
				action:'get',
			},
			method:'POST',
			dataType:'json',
		}, true, (err, user) => {
			dispatch({
				type: APP_LOAD_CURRENT_USER,
				user,
			})
		});
	}
}


