/**
 * Created by kinfen on 16/7/26.
 */
import React from 'react';
import { connect } from 'react-redux';
import { Link } from 'react-router';

import Component from './KComponent';
class SideBar extends Component {
	constructor(props){
		super(props);
		this.state = {
			userHead: KAdm.adminPathEx + "/dist/img/user2-160x160.jpg",
			userName: "Kinfen",
			userState: 1,
			modules: this.props.module

		};
	}
	componentDidMount () {

	}
	handleInputChange (e) {
	}
	renderUserPanel(){
		let stateNode = this.props.userState == "1" ?
			<a href="#"><i className="fa fa-circle text-success"></i> 在线</a> :
			<a href="#"><i className="fa fa-circle text-danger"></i> 离线</a> ;
		return (
			<div className="user-panel">
				<div className="pull-left image">
					<img src={this.props.userHead} className="img-circle" alt="User Image"/>
				</div>
				<div className="pull-left info">
					<p>{this.props.userName}</p>
					{stateNode}
				</div>
			</div>
		);
	}
	finishAnimation () {
		if (!this.isMounted()) return;
		if (this.refs.email) {
			ReactDOM.findDOMNode(this.refs.email).select();
		}
		this.setState({
			isAnimating: false
		});
	}
	renderTreeMenu(modules, level, key){
		var list = [];
		if (modules.length > 0)
		{
			var self = this;
			_.each(modules, function(element, index){
				let cn = level == 0 ?'treeview':'';
				let subNods;
				let rightItem;
				if (element.childs && element.childs.length > 0)
				{
					subNods = (<ul className="treeview-menu">
						{self.renderTreeMenu(element.childs, level + 1, key)}
					</ul>);
					rightItem = <i className="fa fa-angle-left pull-right"></i>

				}
				var link = element.link ? element.link + "?module=" + element._id : "#";
				list.push(
					<li className={cn} key={index}>
						<Link to={link}>
							<i className="fa fa-dashboard"></i><span>{element.name}</span>{rightItem}
						</Link>
						{subNods}
					</li>
				);
			});
		}

		return list;
	}
	render(){

		return (
			<section className="sidebar">
				{this.renderUserPanel()}
				<ul className="sidebar-menu">
					<li className="header">模块组</li>
					{this.renderTreeMenu(this.props.modules, 0, '')}
				</ul>
			</section>
		);
	}
};
export default connect((state) => {
	return {
		modules:state.app.modules
	}
})(SideBar);


