/**
 * Created by kinfen on 2018/1/31.
 */
import React from 'react';
import { connect } from 'react-redux';
import { Link } from 'react-router';
import _ from 'lodash';
import path from 'path';
import {
	Avatar,
	Popover,
	Button,
} from 'antdlib';


class UserPanel extends React.Component{
	constructor(props){
		super(props)
	}
	state = {
		visible:false,
	}
	componentDidMount(){
	}
	handleVisibleChange = (visible) => {
		this.setState({ visible });
	}
	render(){
		let user = this.props.user;
		if (user){
			let styleObj = _.assign({}, this.props.style, {

				margin:'0 30px',
				fontSize:'20px',
				display: 'flex',
				flexDirection:'row',
				justifyContent:'flex-end',
				alignItems:'center',
				cursor:'pointer',
			});
			let logoutPath = path.join(KAdm.adminPath, 'signout');
			let logoutContent = (
				<div>
					<Button type="danger" size="large" style={{
						width:200,
						margin:8,
					}}
					onClick={()=>{
						window.location.href= logoutPath;
					}}
					>
						登出
					</Button>
				</div>
			)
			return (


						<Popover
							content={logoutContent}
							trigger="click"
							visible={this.state.visible}
							onVisibleChange={this.handleVisibleChange}
							placement="bottomRight"
						>
							<div style={styleObj}>
								<Avatar size="large" icon="user" />
								<div style={{
									paddingLeft:15,
								}}>{user.name}
								</div>
							</div>
						</Popover>



			)
		}
		else return null;
	}
}
export default connect((state) => {
	return {
		user:state.app.user
	}
})(UserPanel);
