/**
 * Created by kinfen on 16/7/26.
 */
/**
 * Created by kinfen on 16/7/24.
 */

import React from 'react';

import { connect } from 'react-redux';

import {
    components,
	actions,
	
} from 'kadm-component';
import reduxManager from "kadm-redux-mng";
var store = reduxManager.getStore();
import SiderMenu from './components/SiderMenu';
import {
	Row,
	Col,
	Layout,
} from 'antdlib'
import {
	loadInnerMenus,
} from './actions'


var {
    clearContent,
    selectModel,
    selectList,
} = actions.lists;

var {
    setActiveList,
    setFilter,
    setActiveSort,
} = actions.active;

var {
	ListView,
	KComponent,
	ContentHeader
} = components;

const { Header,  Content, Sider, } = Layout;

class InnerApp extends KComponent{
	constructor(props){
		super(props);
		this.sector  = "#table";
		this.sortName = null;
		this.sortOrder = null;
		this.listContent = null;

	}
	componentWillMount(){
		// this.treeModel = store.getState().lists.model[this.props.params.treemodel];
		this.props.dispatch(loadInnerMenus(this.props.params.app));
		// this.props.dispatch(selectList(this.props.params.model));
	}
	onNodeSelected(event, nodes){
		var self = this;

		// if (nodes.length > 0){

		// 	this.props.dispatch(setFilter(this.treeModel.key.toLowerCase(), {
		// 		inverted:false,
		// 		value:[nodes[0].id],
		// 	}));
		// 	this.props.dispatch(selectTreeNode(nodes[0].id));
		// }

	}
	onTitleSelected(event){
		console.log(event);
	}
	render(){
		var model = this.props.params.model;
		var state = store.getState();

		// if (this.props.currentModel && this.props.currentModel.key != model){
		// 	this.props.dispatch(clearContent());
		// 	this.props.dispatch(selectModel(this.props.params.model));
		// 	this.props.dispatch(selectList(this.props.params.model));
		// 	return null;
		// }

		return (

			<Layout>
				<Header className="content-header">
					<ContentHeader/>
				</Header>
				<Content className="page-content" style={{ margin: '0 16px', padding: 24, minHeight: 280 }}>
				
					<Layout>
						<Header style={{
							background:'#fff',
							marginBottom:30,
							display:'none',//not display now
						}}>
							
						</Header>
						<Layout>
							<SiderMenu style={{ background: '#fff' }} modules={this.props.modules} params={this.props.params} onNodeSelected={this.onNodeSelected.bind(this)} model={this.treeModel}/>
							
							<Content style={{
								marginLeft:30,
							}}>
								{this.props.children}
							</Content>
						</Layout>
					</Layout>
				</Content>
			</Layout>
			
		)
	}
};
export {
	InnerApp
}
export default connect((state) => {
	return {
		modules:state.innerapp.modules,
		loading:state.lists.loading,
		columns:state.active.columns,
		currentModel:state.lists.currentModel,
	}
})(InnerApp)
