/**
 * Created by kinfen on 16/7/26.
 */
import  {
	updateModulesTree,
	showLoading,
	loadCurrentUser,
} from '../action';
import reduxManager from "kadm-redux-mng";
var store = reduxManager.getStore();
var name = '';
const control = {
	init:function()
	{
		var self = this;
		this.loadSideBarMenu();
		store.dispatch(loadCurrentUser());

	},
	api:function(opt, isNeedCsrfVaild, cb)
	{
		if (isNeedCsrfVaild)
		{
			var key = "x-csrf-token";
			opt.beforeSend=function(req) {
				req.setRequestHeader(key, KAdm.csrf.header[key]);
			};
			//opt.data[KAdm.csrf.key] = KAdm.csrf.value;
		}
		if (!opt.success && !opt.error){
			if (cb){
				opt.success = (data)=>{
					cb(null, data);
				}
				opt.error = (xhr, error)=>{
					cb(xhr.responseJSON, null);
				}
			}
		}
		$.ajax(opt);
	},
	showLoading:function(b, delay){
		if (!b && delay && delay > 0)
		{
			setTimeout(function(){
				store.dispatch(showLoading(b))
				$('#content').show();
			}, delay);
		}
		else
		{
			store.dispatch(showLoading(b))
			if (b)
			{
				$('#content').hide();
			}
			else
			{
				$('#content').show();
			}
		}


	},
	setModuleData:function(data){
		store.dispatch(updateModulesTree(data))
	},
	loadSideBarMenu:function()
	{
		var self = this;
		this.api({
			url: KAdm.adminPath + '/api2/Module/tree',
			success: function (data) {
				self.setModuleData(data.list);
			},
			error: function () {
				console.log('error');
			}

		});
	}
}

export default control;
