/**
 * Created by kinfen on 16/7/26.
 */
/**
 * Created by kinfen on 16/7/24.
 */
import { routerReducer, routerMiddleware, push, replace } from 'react-router-redux';
import { createStore, combineReducers, applyMiddleware, compose } from 'redux';
import { browserHistory } from 'react-router';
import thunk from 'redux-thunk';
import app from './reducer';
import item from './components/itemview/reducer';
import active from './components/listview/active/reducer';
import lists from './components/listview/reducer';
import innerapp from './screens/innerapp/reducer';

//import { loadItems } from './screens/List/actions';
//
//// Combine the reducers to one state
var reducerMap = {
	app,
	lists,
	active,
	item,
	innerapp,
	routing: routerReducer,
}
var reducers = combineReducers(reducerMap);
// Create the store
var store = createStore(
	reducers,
	compose(
		applyMiddleware(
			// Support thunked actions and react-router-redux
			thunk,
			routerMiddleware(browserHistory)
		),
		// Support the Chrome DevTools extension
		window.devToolsExtension ? window.devToolsExtension() : f => f
	)
);
store.reducerMap = reducerMap;
store.subscribe(() => {
	// Get all the necessary data
	const state = store.getState();
	console.log(arguments);
	console.log(state);
});
export {
	reducerMap
}
export default store;
