require=(function(){function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s}return e})()({1:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.APP_LOAD_CURRENT_USER = exports.APP_SHOW_MAIN_LOADING = exports.APP_MODULE_SELECTED = exports.APP_SIDE_BAR_LOADED = undefined;
exports.updateModulesTree = updateModulesTree;
exports.selecteModule = selecteModule;
exports.showLoading = showLoading;
exports.loadCurrentUser = loadCurrentUser;

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var controlAPI = function controlAPI(opt, isNeedCsrfVaild, cb) {
	if (isNeedCsrfVaild) {
		var key = "x-csrf-token";
		opt.beforeSend = function (req) {
			req.setRequestHeader(key, KAdm.csrf.header[key]);
		};
		//opt.data[KAdm.csrf.key] = KAdm.csrf.value;
	}
	if (!opt.success && !opt.error) {
		if (cb) {
			opt.success = function (data) {
				cb(null, data);
			};
			opt.error = function (xhr, error) {
				cb(xhr.responseJSON, null);
			};
		}
	}
	$.ajax(opt);
}; /**
    * Created by kinfen on 16/8/5.
    */
var APP_SIDE_BAR_LOADED = exports.APP_SIDE_BAR_LOADED = "APP_SIDE_BAR_LOADED";
function updateModulesTree(modules) {
	return {
		type: APP_SIDE_BAR_LOADED,
		modules: modules
	};
}

var APP_MODULE_SELECTED = exports.APP_MODULE_SELECTED = "APP_MODULE_SELECTED";
function selecteModule(selectedModule) {
	return {
		type: APP_MODULE_SELECTED,
		selectedModule: selectedModule
	};
}

var APP_SHOW_MAIN_LOADING = exports.APP_SHOW_MAIN_LOADING = "APP_SHOW_MAIN_LOADING";
function showLoading(bool) {
	return {
		type: APP_SHOW_MAIN_LOADING,
		mainloading: bool
	};
}

var APP_LOAD_CURRENT_USER = exports.APP_LOAD_CURRENT_USER = "APP_LOAD_CURRENT_USER";
function loadCurrentUser() {
	return function (dispatch, getState) {
		var url = _path2.default.join(KAdm.adminPath, 'api2', 'User', KAdm.user.id);
		controlAPI({
			url: url,
			data: {
				action: 'get'
			},
			method: 'POST',
			dataType: 'json'
		}, true, function (err, user) {
			dispatch({
				type: APP_LOAD_CURRENT_USER,
				user: user
			});
		});
	};
}

},{"path":14}],2:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.loadItemsData = loadItemsData;
exports.loadItemData = loadItemData;
exports.itemDataLoaded = itemDataLoaded;
exports.itemDataLoadingError = itemDataLoadingError;
exports.itemDeleteItem = itemDeleteItem;
exports.itemCreate = itemCreate;
exports.itemCreateSuccess = itemCreateSuccess;
exports.itemCreateFail = itemCreateFail;
var ITEM_LOAD_DATAS = exports.ITEM_LOAD_DATAS = "ITEM_LOAD_DATAS";
function loadItemsData() {
	var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	return function (dispatch, getState) {
		dispatch({ type: ITEM_LOAD_DATAS });
		var state = getState();
		var currentList = state.lists.currentModel;
		currentList.loadItems({
			search: state.active.search,
			filters: state.active.filters,
			sort: state.active.sort,
			columns: state.active.columns,
			page: state.lists.page
		}, function (err, items) {
			if (items) {
				// if (page.index !== drag.page && drag.item) {
				// 	// add the dragging item
				// 	if (page.index > drag.page) {
				// 		_items.results.unshift(drag.item);
				// 	} else {
				// 		_items.results.push(drag.item);
				// 	}
				// }
				// _itemsResultsClone = items.results.slice(0);
				//

				// TODO Reenable this
				// if (options.success && options.id) {
				// 	// flashes a success background on the row
				// 	_rowAlert.success = options.id;
				// }
				// if (options.fail && options.id) {
				// 	// flashes a failure background on the row
				// 	_rowAlert.fail = options.id;
				// }
				dispatch(itemsLoaded(items));
			} else {
				dispatch(itemLoadingError(err));
			}
		});
	};
}

/**
 * Select an item
 *
 * @param  {String} itemId The item ID
 */
var ITEM_SELECT = exports.ITEM_SELECT = "ITEM_SELECT";
var ITEM_LOAD_DATA = exports.ITEM_LOAD_DATA = "ITEM_LOAD_DATA";
function loadItemData(itemId) {
	return function (dispatch, getState) {
		dispatch({
			type: ITEM_SELECT,
			id: itemId
		});
		dispatch({
			type: ITEM_LOAD_DATA
		});
		var state = getState();
		var model = state.lists.currentModel;
		// Load a specific item with the utils/List.js helper
		model.loadItem(itemId, { drilldown: true }, function (err, itemData) {
			if (err || !itemData) {
				console.log('Error loading item data', err);
				dispatch(itemDataLoadingError(err));
			} else {
				dispatch(itemDataLoaded(itemData));
			}
		});
	};
}
/**
 * Called when data of the current item is loaded
 *
 * @param  {Object} data The item data
 */
var ITEM_DATA_LOADING_SUCCESS = exports.ITEM_DATA_LOADING_SUCCESS = "ITEM_DATA_LOADING_SUCCESS";
function itemDataLoaded(data) {
	return {
		type: ITEM_DATA_LOADING_SUCCESS,
		data: data
	};
}

/**
 * Called when there was an error during the loading of the current item data,
 * will retry loading the data ever NETWORK_ERROR_RETRY_DELAY milliseconds
 *
 * @param  {Object} error The error
 */
var ITEM_PROCESS_ERROR = exports.ITEM_PROCESS_ERROR = "ITEM_PROCESS_ERROR";
function itemDataLoadingError(err) {
	return {
		type: ITEM_PROCESS_ERROR,
		error: err
	};
}

/**
 * Deletes an item and optionally redirects to the current list URL
 *
 * @param  {String} id     The ID of the item we want to delete
 * @param  {Object} router A react-router router object. If this is passed, we
 *                         redirect to Keystone.adminPath/currentList.path!
 */
var ITEM_DELETE = exports.ITEM_DELETE = "ITEM_DELETE";
function itemDeleteItem(id, router) {
	return function (dispatch, getState) {
		var list = getState().lists.currentModel;
		list.deleteItem(id, function (err) {
			// If a router is passed, redirect to the current list path,
			// otherwise stay where we are
			if (router) {
				router.push(Keystone.adminPath + "/" + list.path);
			}
			// TODO Proper error handling
			if (err) {
				alert('Error deleting item, please try again!');
				console.log(err);
			} else {
				dispatch({
					type: ITEM_DELETE,
					id: id
				});
			}
		});
	};
}

var ITEM_CREATE = exports.ITEM_CREATE = "ITEM_CREATE";
function itemCreate(formData, callback) {
	return function (dispatch, getState) {
		var list = getState().lists.currentModel;
		list.createItem(formData, function (err, data) {
			if (data) {
				dispatch(itemCreateSuccess(data));
			} else {
				if (err.error === 'database error') {
					err.error = err.detail.errmsg;
				}
				dispatch(itemCreateFail(err));
			}
			callback(err, data);
		});
	};
}

var ITEM_CREATE_SUCCESS = exports.ITEM_CREATE_SUCCESS = "ITEM_CREATE_SUCCESS";
function itemCreateSuccess(data) {
	return {
		type: ITEM_CREATE_SUCCESS,
		createdData: data
	};
}
var ITEM_CREATE_FAIL = exports.ITEM_CREATE_FAIL = "ITEM_CREATE_FAIL";
function itemCreateFail(err) {
	return {
		type: ITEM_CREATE_FAIL,
		err: err
	};
}

},{}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var initialState = {
	data: null,
	id: null,
	loading: true,
	ready: false,
	error: null
}; /**
    * Created by kinfen on 16/7/26.
    */


function item() {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
	var action = arguments[1];

	switch (action.type) {
		case _actions.ITEM_SELECT:
			return (0, _objectAssign2.default)({}, state, {
				id: action.id,
				data: null
			});
		case _actions.ITEM_LOAD_DATA:
			return (0, _objectAssign2.default)({}, state, {
				loading: true
			});
		case _actions.ITEM_DATA_LOADING_SUCCESS:
			var obj = (0, _objectAssign2.default)({}, state, {
				data: action.data,
				loading: false,
				ready: true,
				error: null
			});
			return obj;
		case _actions.ITEM_PROCESS_ERROR:
			return (0, _objectAssign2.default)({}, state, {
				data: null,
				loading: false,
				ready: true,
				error: action.error
			});
		case _actions.ITEM_CREATE_SUCCESS:
			return (0, _objectAssign2.default)({}, state, {
				createData: action.createData
			});
		case _actions.ITEM_CREATE_FAIL:
			return (0, _objectAssign2.default)({}, state, {
				error: action.err
			});
		default:
			return state;
	}
}

exports.default = item;

},{"./actions":2,"object-assign":13}],4:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.LIST_CONTENT_ERROR = exports.LIST_POPOVER_LOCK_CHANGE = exports.LIST_CLEAR_CONTENT = exports.LIST_CONTENT_LOAD = exports.LIST_CONTENT_LOADING = exports.LIST_PAGE = exports.LIST_SELECT_MODEL = undefined;
exports.selectModel = selectModel;
exports.listPage = listPage;
exports.contentLoading = contentLoading;
exports.clearContent = clearContent;
exports.loadDataFromState = loadDataFromState;
exports.lockPopover = lockPopover;

var _objectAssign = require("object-assign");

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _actions = require("./active/actions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var findModelName = function findModelName(name) {
	if (KAdm.lists.hasOwnProperty(name))
		//return directly if supply a field name
		return name;else {
		//find field name to return if supplied a path name;
		var targetName = _lodash2.default.findKey(KAdm.lists, function (o) {
			return o.path == name;
		});
		return targetName;
	}
}; /**
    * Created by kinfen on 16/7/26.
    */

var LIST_SELECT_MODEL = exports.LIST_SELECT_MODEL = "LIST_SELECT_MODEL";
function selectModel(modelName) {
	modelName = findModelName(modelName);

	return function (dispatch, getState) {
		var lists = getState().lists;
		var actions = KAdm.menuActions;
		var permissions = KAdm.permissions[modelName];
		if (permissions) actions = _lodash2.default.filter(actions, function (o) {
			return permissions.indexOf(o.code) != -1;
		});else actions = [];
		dispatch({
			type: LIST_SELECT_MODEL,
			currentModel: lists.model[modelName],
			menuActions: actions
		});
		dispatch((0, _actions.setActiveList)(lists.model[modelName], modelName));
	};
}

// export const LIST_SELECT_LIST = "LIST_SELECT_LIST";
// export function selectList(list){
// 	list = findModelName(list);
// 	return (dispatch, getState) => {
// 		let lists = getState().lists;

// 		let actions = KAdm.menuActions;
// 		let permissions = KAdm.permissions[list];
// 		if (permissions) actions = _.filter(actions, (o) => permissions.indexOf(o.code) != -1);
// 		else actions = [];

// 		dispatch ({
// 			type:LIST_SELECT_LIST,
// 			list:lists.model[list],
// 			menuActions:actions,
// 		});
// 		dispatch(setActiveList(lists.model[list], list));
// 		if (permissions) {
// 			dispatch(loadDataFromState());
// 		}
// 	};
// }


var LIST_PAGE = exports.LIST_PAGE = "LIST_PAGE";
function listPage(page) {
	return function (dispatch, getState) {
		dispatch({
			type: LIST_PAGE,
			page: page
		});
		dispatch(loadDataFromState());
	};
}

var LIST_CONTENT_LOADING = exports.LIST_CONTENT_LOADING = "LIST_CONTENT_LOADING";
function contentLoading(isLoading) {
	return {
		type: LIST_CONTENT_LOADING,
		loading: isLoading
	};
}

/**
 * 更新content内容
 */
var LIST_CONTENT_LOAD = exports.LIST_CONTENT_LOAD = "LIST_CONTENT_LOAD";
// function tableList(data) {
// 	var self = this;
// 	data = _.map(data, function (obj) {
// 		obj.fields.id = obj.id;
// 		return _.mapValues(obj.fields, function (target) {
// 			if (typeof(target) == "object" && target.name) {
// 				return target.name;
// 			}
// 			return target;
// 		})

// 	});
// 	return data;
// }


function contentRecieve(data) {
	return function (dispatch, getState) {

		dispatch({
			type: LIST_CONTENT_LOAD,
			totalPages: Math.ceil(data.count / getState().lists.page.size),
			total: data.count,
			data: data.results
		});
	};
}

var LIST_CLEAR_CONTENT = exports.LIST_CLEAR_CONTENT = "LIST_CLEAR_CONTENT";
function clearContent() {
	return function (dispatch, getState) {

		dispatch({
			type: LIST_CLEAR_CONTENT,
			totalPages: 0,
			total: 0,
			data: []
		});
	};
}

function contentError(error) {
	return {
		type: LIST_CONTENT_ERROR,
		error: error
	};
}

/**
 *
 *
 * @returns {function(*, *)}
 *
 * search: "",
 * filters:[{
 * 	field:{}
 * 	value:{ inverse:false, value:[]}
 * }],
 * sort:{
 * 	input:"-publishedDate"
 * 	isDefaultSore:true,
 * 	rawInput:"-publishedDate",
 * 	paths:[{field}]
 * 	},
 * 	column:[{field:{}, label:"", path:""}],
 * 	page:{
 * 		index:1,
 * 		size:1
 *
 * 	}
 *
 */

function loadDataFromState() {

	return function (dispatch, getState) {
		dispatch(contentLoading(true));
		var state = getState();
		var currentList = state.lists.currentModel;
		currentList.loadItems({
			search: state.active.search,
			filters: state.active.filters,
			sort: state.active.sort,
			columns: state.active.columns,
			page: state.lists.page
		}, function (err, items) {
			if (items) {
				dispatch(contentRecieve(items));
			} else {
				dispatch(contentError(err));
			}
			dispatch(contentLoading(false));
		});
	};
}

var LIST_POPOVER_LOCK_CHANGE = exports.LIST_POPOVER_LOCK_CHANGE = "LIST_POPOVER_LOCK_CHANGE";
function lockPopover(popoverLock) {
	return function (dispatch, getState) {
		dispatch({
			type: LIST_POPOVER_LOCK_CHANGE,
			popoverLock: popoverLock
		});
	};
}

var LIST_CONTENT_ERROR = exports.LIST_CONTENT_ERROR = "LIST_CONTENT_ERROR";

},{"./active/actions":5,"lodash":undefined,"object-assign":13}],5:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.LIST_CLEAR_ALL_FILTERS = exports.LIST_CLEAR_FILTER = exports.LIST_ADD_FILTER = exports.LIST_SET_ACTIVE_LIST = exports.LIST_SET_ACTIVE_COLUMNS = exports.LIST_SET_ACTIVE_SORT = exports.LIST_SET_ACTIVE_SEARCH = undefined;
exports.setActiveSearch = setActiveSearch;
exports.setActiveSort = setActiveSort;
exports.setActiveColumns = setActiveColumns;
exports.setActiveList = setActiveList;
exports.clearFilter = clearFilter;
exports.clearAllFilters = clearAllFilters;
exports.setFilter = setFilter;

var _actions = require("../actions");

/**
 * Active actions
 */
var LIST_SET_ACTIVE_SEARCH = exports.LIST_SET_ACTIVE_SEARCH = "LIST_SET_ACTIVE_SEARCH"; /**
                                                                                         * Created by kinfen on 16/8/19.
                                                                                         */

function setActiveSearch(searchString) {
	return {
		type: LIST_SET_ACTIVE_SEARCH,
		searchString: searchString
	};
}

var LIST_SET_ACTIVE_SORT = exports.LIST_SET_ACTIVE_SORT = "LIST_SET_ACTIVE_SORT";
function setActiveSort(path) {
	return function (dispatch, getState) {
		// TODO Decouple from state somehow
		var list = getState().lists.currentModel;
		var sort = list.expandSort(path);
		dispatch({
			type: LIST_SET_ACTIVE_SORT,
			sort: sort
		});
	};
}

var LIST_SET_ACTIVE_COLUMNS = exports.LIST_SET_ACTIVE_COLUMNS = "LIST_SET_ACTIVE_COLUMNS";
function setActiveColumns(columns) {
	return function (dispatch, getState) {
		// TODO Decouple from state somehow
		var list = getState().lists.currentModel;
		var expandedColumns = list.expandColumns(columns);
		dispatch({
			type: LIST_SET_ACTIVE_COLUMNS,
			columns: expandedColumns
		});
	};
}

var LIST_SET_ACTIVE_LIST = exports.LIST_SET_ACTIVE_LIST = "LIST_SET_ACTIVE_LIST";
function setActiveList(list, id) {
	return {
		type: LIST_SET_ACTIVE_LIST,
		list: list,
		id: id
	};
}

/**
 * Filtering actions
 */
var LIST_ADD_FILTER = exports.LIST_ADD_FILTER = "LIST_ADD_FILTER";
function addFilter(filter) {
	// TODO Make this a pure function again, find better way to call loadItems()
	// after each filtering change!
	return function (dispatch) {
		dispatch({
			type: LIST_ADD_FILTER,
			filter: filter
		});
	};
}

var LIST_CLEAR_FILTER = exports.LIST_CLEAR_FILTER = "LIST_CLEAR_FILTER";
function clearFilter(path) {
	// TODO Make this a pure function again, find better way to call loadItems()
	// after each filtering change!
	return function (dispatch) {
		dispatch({
			type: LIST_CLEAR_FILTER,
			path: path
		});
		dispatch((0, _actions.loadDataFromState)());
	};
}

var LIST_CLEAR_ALL_FILTERS = exports.LIST_CLEAR_ALL_FILTERS = "LIST_CLEAR_ALL_FILTERS";
function clearAllFilters() {
	// TODO Make this a pure function again, find better way to call loadItems()
	// after each filtering change!
	return function (dispatch) {
		dispatch({
			type: LIST_CLEAR_ALL_FILTERS
		});
		dispatch((0, _actions.loadDataFromState)());
	};
}

function setFilter(path, value) {
	return function (dispatch, getState) {
		var state = getState();
		var activeFilters = state.active.filters;
		var currentList = state.lists.currentModel;
		var page = state.lists.page;
		// Get current filter
		var filter = activeFilters.filter(function (i) {
			return i.field.path === path;
		})[0];
		// If a filter exists already, update its value
		if (filter) {
			filter.value = value;
			// Otherwise construct a new one
		} else {
			var field = currentList.fields[path];
			if (!field) {
				console.warn('Invalid Filter path specified:', path);
				return;
			}
			filter = {
				field: field,
				value: value
			};
		}
		dispatch(addFilter(filter));
		dispatch((0, _actions.listPage)({
			index: 1,
			size: page.size
		}));
	};
}

},{"../actions":4}],6:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var initialState = {
	columns: null,
	filters: [],
	search: '',
	sort: {
		input: '',
		isDefaultSort: false,
		paths: [],
		rawInput: ''
	}
};

/**
 * Manage the active state
 */
/**
 * Created by kinfen on 16/8/19.
 */

function active() {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
	var action = arguments[1];

	switch (action.type) {
		case _actions.LIST_SET_ACTIVE_LIST:
			var expandColumns = action.list.expandColumns(action.list.defaultColumns);
			return (0, _objectAssign2.default)({}, state, {
				id: action.id,
				columns: state.id == action.id ? state.columns || expandColumns : expandColumns,
				filters: [],
				search: '',
				sort: action.list.expandSort(action.list.defaultSort)
			});
		case _actions.LIST_SET_ACTIVE_SEARCH:
			return (0, _objectAssign2.default)({}, state, {
				search: action.searchString
			});
		case _actions.LIST_SET_ACTIVE_SORT:
			return (0, _objectAssign2.default)({}, state, {
				sort: action.sort
			});
		case _actions.LIST_SET_ACTIVE_COLUMNS:
			return (0, _objectAssign2.default)({}, state, {
				columns: action.columns
			});
		case _actions.LIST_ADD_FILTER:
			return (0, _objectAssign2.default)({}, state, {
				// Override existing filter with field path,
				// otherwise add to filters array
				filters: _lodash2.default.unionWith([action.filter], state.filters, function (stateFilter, actionFilter) {
					return stateFilter.field.path === actionFilter.field.path;
				})
			});
		case _actions.LIST_CLEAR_FILTER:
			var newFilters = _lodash2.default.filter(state.filters, function (filter) {
				return filter.field.path !== action.path;
			});
			return (0, _objectAssign2.default)({}, state, {
				filters: newFilters
			});
		case _actions.LIST_CLEAR_ALL_FILTERS:
			return (0, _objectAssign2.default)({}, state, {
				filters: []
			});
		default:
			return state;
	}
}

exports.default = active;

},{"./actions":5,"lodash":undefined,"object-assign":13}],7:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _List = require('../../../utils/List');

var _List2 = _interopRequireDefault(_List);

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var initialState = {
	model: {},
	search: "",
	list: null,
	currentModel: null,
	filters: [],
	sort: null,
	page: { size: 10, index: 1 },
	columns: null,
	loading: false,
	totalPages: 1,
	data: [],
	catid: null,
	popoverLock: false
}; /**
    * Created by kinfen on 16/7/26.
    */


var initialLists = KAdm.lists;
KAdm.model = {};
for (var name in initialLists) {
	if ({}.hasOwnProperty.call(initialLists, name)) {
		var currentList = initialLists[name];
		initialState.model[currentList.key] = new _List2.default(currentList);
		KAdm.model[currentList.key] = initialState.model[currentList.key];
	}
}

function list() {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
	var action = arguments[1];

	switch (action.type) {
		case _actions.LIST_SELECT_MODEL:
			return _lodash2.default.assign({}, state, {
				currentModel: action.currentModel,
				menuActions: action.menuActions
			});
		case _actions.LIST_CLEAR_CONTENT:
			return _lodash2.default.assign({}, state, {
				totalPages: 0,
				total: 0,
				data: []
			});
		case _actions.LIST_COLUMNS:
			return _lodash2.default.assign({}, state, {
				columns: action.columns
			});
		case _actions.LIST_FILTERS:
			return _lodash2.default.assign({}, state, {
				filters: action.filters
			});
		case _actions.LIST_PAGE:
			return _lodash2.default.assign({}, state, {
				page: action.page
			});
		case _actions.LIST_SORT:
			return _lodash2.default.assign({}, state, {
				sort: action.sort
			});
		case _actions.LIST_CONTENT_LOADING:
			return _lodash2.default.assign({}, state, {
				loading: action.loading
			});
		case _actions.LIST_CONTENT_LOAD:
			return _lodash2.default.assign({}, state, {
				data: action.data,
				totalPages: action.totalPages,
				total: action.total
			});

		case _actions.LIST_CONTENT_ERROR:
			return _lodash2.default.assign({}, state, {
				categoryLoading: false
			});
		case _actions.LIST_POPOVER_LOCK_CHANGE:
			return _lodash2.default.assign({}, state, {
				popoverLock: action.popoverLock
			});
		default:
			return state;
	}
}
exports.default = list;

},{"../../../utils/List":12,"./actions":4,"lodash":undefined}],8:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _action = require('./action');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by kinfen on 16/7/27.
 */
var initialState = {
	modules: {},
	lists: {},
	mainloading: false,
	selectedModule: null
};

function reducer() {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
	var action = arguments[1];

	switch (action.type) {
		case _action.APP_SIDE_BAR_LOADED:
			return _lodash2.default.assign({}, state, {
				modules: action.modules
			});
		case _action.APP_SHOW_MAIN_LOADING:
			return _lodash2.default.assign({}, state, {
				mainloading: action.mainloading
			});

		case _action.APP_LOAD_CURRENT_USER:
			return _lodash2.default.assign({}, state, {
				user: action.user
			});
		case _action.APP_MODULE_SELECTED:
			return _lodash2.default.assign({}, state, {
				selectedModule: action.selectedModule
			});
		default:
			return state;
	}
}
exports.default = reducer;

},{"./action":1,"lodash":undefined}],9:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.loadInnerMenus = loadInnerMenus;
exports.selecteModule = selecteModule;
exports.initListFilters = initListFilters;
/**
 * Created by kinfen on 16/7/26.
 */

var controlAPI = function controlAPI(opt, isNeedCsrfVaild, cb) {
	if (isNeedCsrfVaild) {
		var key = "x-csrf-token";
		opt.beforeSend = function (req) {
			req.setRequestHeader(key, KAdm.csrf.header[key]);
		};
		//opt.data[KAdm.csrf.key] = KAdm.csrf.value;
	}
	if (!opt.success && !opt.error) {
		if (cb) {
			opt.success = function (data) {
				cb(null, data);
			};
			opt.error = function (xhr, error) {
				cb(xhr.responseJSON, null);
			};
		}
	}
	$.ajax(opt);
};

var INNERAPP_MODULE_LOADED = exports.INNERAPP_MODULE_LOADED = "INNERAPP_MODULE_LOADED";

function loadInnerMenus(module) {
	var _this = this;

	return function (dispatch, getState) {

		var self = _this;
		controlAPI({
			url: KAdm.adminPath + '/api2/AppModule/tree',
			data: {
				module: module
			},
			method: 'GET',
			dataType: 'json'
		}, true, function (err, data) {
			if (err) return;

			dispatch({
				type: INNERAPP_MODULE_LOADED,
				modules: data.list
			});
		});
	};
}

var INNERAPP_MODULE_SELECTED = exports.INNERAPP_MODULE_SELECTED = "INNERAPP_MODULE_SELECTED";
function selecteModule(selectedModule) {
	return {
		type: INNERAPP_MODULE_SELECTED,
		selectedModule: selectedModule
	};
}

var INNERAPP_MODULE_FILTERS = exports.INNERAPP_MODULE_FILTERS = "INNERAPP_MODULE_FILTERS";
function initListFilters(filter, value) {
	return {
		type: INNERAPP_MODULE_FILTERS,
		filter: {
			filter: filter,
			value: value
		}
	};
}

},{}],10:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Created by kinfen on 16/7/26.
 */
var initialState = {
	modules: null,
	selectedModule: null,
	filter: null
};

function innerapp() {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
	var action = arguments[1];

	switch (action.type) {
		case _actions.INNERAPP_MODULE_LOADED:
			return _lodash2.default.assign({}, state, {
				modules: action.modules
			});
		case _actions.INNERAPP_MODULE_SELECTED:
			return _lodash2.default.assign({}, state, {
				selectedModule: action.selectedModule
			});
		case _actions.INNERAPP_MODULE_FILTERS:
			return _lodash2.default.assign({}, state, {
				filter: action.filter
			});
		default:
			return state;
	}
}

exports.default = innerapp;

},{"./actions":9,"lodash":undefined}],11:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.reducerMap = undefined;
var _arguments = arguments; /**
                             * Created by kinfen on 16/7/26.
                             */
/**
 * Created by kinfen on 16/7/24.
 */

var _reactRouterRedux = require('react-router-redux');

var _redux = require('redux');

var _reactRouter = require('react-router');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _reducer = require('./reducer');

var _reducer2 = _interopRequireDefault(_reducer);

var _reducer3 = require('./components/itemview/reducer');

var _reducer4 = _interopRequireDefault(_reducer3);

var _reducer5 = require('./components/listview/active/reducer');

var _reducer6 = _interopRequireDefault(_reducer5);

var _reducer7 = require('./components/listview/reducer');

var _reducer8 = _interopRequireDefault(_reducer7);

var _reducer9 = require('./screens/innerapp/reducer');

var _reducer10 = _interopRequireDefault(_reducer9);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//import { loadItems } from './screens/List/actions';
//
//// Combine the reducers to one state
var reducerMap = {
	app: _reducer2.default,
	lists: _reducer8.default,
	active: _reducer6.default,
	item: _reducer4.default,
	innerapp: _reducer10.default,
	routing: _reactRouterRedux.routerReducer
};
var reducers = (0, _redux.combineReducers)(reducerMap);
// Create the store
var store = (0, _redux.createStore)(reducers, (0, _redux.compose)((0, _redux.applyMiddleware)(
// Support thunked actions and react-router-redux
_reduxThunk2.default, (0, _reactRouterRedux.routerMiddleware)(_reactRouter.browserHistory)),
// Support the Chrome DevTools extension
window.devToolsExtension ? window.devToolsExtension() : function (f) {
	return f;
}));
store.reducerMap = reducerMap;
store.subscribe(function () {
	// Get all the necessary data
	var state = store.getState();
	console.log(_arguments);
	console.log(state);
});
exports.reducerMap = reducerMap;
exports.default = store;

},{"./components/itemview/reducer":3,"./components/listview/active/reducer":6,"./components/listview/reducer":7,"./reducer":8,"./screens/innerapp/reducer":10,"react-router":undefined,"react-router-redux":undefined,"redux":undefined,"redux-thunk":undefined}],12:[function(require,module,exports){
'use strict';

/**
 * Helper method to handle List operations, e.g. creating items, deleting items,
 * getting information about those lists, etc.
 */

var listToArray = require('list-to-array');
var qs = require('qs');
var xhr = require('xhr');
var _ = require('lodash');
// Filters for truthy elements in an array
var truthy = function truthy(i) {
	return i;
};
// import control from "../App/shared/Control";

/**
 * Get the columns of a list, structured by fields and headings
 *
 * @param  {Object} list The list we want the columns of
 *
 * @return {Array}       The columns
 */
function getColumns(list) {
	return list.uiElements.map(function (col) {
		if (col.type === 'heading') {
			return { type: 'heading', content: col.content };
		} else {
			var field = list.fields[col.field];
			return field ? { type: 'field', field: field, title: field.label, path: field.path } : null;
		}
	}).filter(truthy);
}

/**
 * Make an array of filters an object keyed by the filtering path
 *
 * @param  {Array} filterArray The array of filters
 *
 * @return {Object}            The corrected filters, keyed by path
 */
function getFilters(filterArray) {
	var filters = {};
	filterArray.forEach(function (filter) {
		filters[filter.field.path] = filter.value;
	});
	return filters;
};

/**
 * Get the sorting string for the URI
 *
 * @param  {Array} sort.paths The paths we want to sort
 *
 * @return {String}           All the sorting queries we want as a string
 */
function getSortString(sort) {
	return sort.paths.map(function (i) {
		// If we want to sort inverted, we prefix a "-" before the sort path
		return i.invert ? '-' + i.path : i.path;
	}).filter(truthy).join(',');
};

/**
 * Build a query string from a bunch of options
 */
function buildQueryString(options) {
	var query = {};
	if (options.search) query.search = options.search;
	if (options.filters.length) query.filters = JSON.stringify(getFilters(options.filters));
	if (options.columns) query.fields = options.columns.map(function (i) {
		return i.path;
	}).join(',');
	if (options.page && options.page.size) query.limit = options.page.size;
	if (options.page && options.page.index > 1) query.skip = (options.page.index - 1) * options.page.size;
	if (options.sort) query.sort = getSortString(options.sort);
	query.expandRelationshipFields = true;
	return '?' + qs.stringify(query);
};

/**
 * The main list helper class
 *
 * @param {Object} options
 */
var List = function List(options) {
	// TODO these options are possibly unused
	_.assign(this, options);
	this.columns = getColumns(this);
	this.expandedDefaultColumns = this.expandColumns(this.defaultColumns);
	this.defaultColumnPaths = this.expandedDefaultColumns.map(function (i) {
		return i.path;
	}).join(',');
};

/**
 * Create an item via the API
 *
 * @param  {FormData} formData The submitted form data
 * @param  {Function} callback Called after the API call
 */
List.prototype.createItem = function (formData, callback) {
	xhr({
		url: KAdm.adminCore + '/api/' + this.path + '/create',
		responseType: 'json',
		method: 'POST',
		headers: KAdm.csrf.header,
		body: formData
	}, function (err, resp, data) {

		if (err) callback(err);
		if (resp.statusCode === 200) {
			callback(null, data);
		} else {
			// NOTE: xhr callback will be called with an Error if
			//  there is an error in the browser that prevents
			//  sending the request. A HTTP 500 response is not
			//  going to cause an error to be returned.
			callback(data, null);
		}
	});
};

/**
 * Update a specific item
 *
 * @param  {String}   id       The id of the item we want to update
 * @param  {FormData} formData The submitted form data
 * @param  {Function} callback Called after the API call
 */
List.prototype.updateItem = function (id, formData, callback) {
	xhr({
		url: KAdm.adminCore + '/api/' + this.path + '/' + id,
		responseType: 'json',
		method: 'POST',
		headers: _.assign({}, KAdm.csrf.header),
		body: formData
	}, function (err, resp, data) {
		if (err) return callback(err);
		if (resp.statusCode === 200) {
			callback(null, data);
		} else {
			callback(data);
		}
	});
};

List.prototype.expandColumns = function (input) {
	var _this = this;

	var nameIncluded = false;
	var cols = listToArray(input).map(function (i) {
		var split = i.split('|');
		var path = split[0];
		var width = split[1];
		if (path === '__name__') {
			path = _this.namePath;
		}
		var field = _this.fields[path];
		if (!field) {
			// TODO: Support arbitary document paths
			if (!_this.hidden) {
				if (path === _this.namePath) {
					console.warn('List ' + _this.key + ' did not specify any default columns or a name field');
				} else {
					console.warn('List ' + _this.key + ' specified an invalid default column: ' + path);
				}
			}
			return;
		}
		if (path === _this.namePath) {
			nameIncluded = true;
		}
		return {
			field: field,
			label: field.label,
			path: field.path,
			type: field.type,
			width: width
		};
	}).filter(truthy);
	if (!nameIncluded) {
		cols.unshift({
			type: 'id',
			label: 'ID',
			path: 'id'
		});
	}
	return cols;
};

List.prototype.expandSort = function (input) {
	var _this2 = this;

	var sort = {
		rawInput: input || this.defaultSort,
		isDefaultSort: false
	};
	sort.input = sort.rawInput;
	if (sort.input === '__default__') {
		sort.isDefaultSort = true;
		sort.input = this.sortable ? 'sortOrder' : this.namePath;
	}
	sort.paths = listToArray(sort.input).map(function (path) {
		var invert = false;
		if (path.charAt(0) === '-') {
			invert = true;
			path = path.substr(1);
		} else if (path.charAt(0) === '+') {
			path = path.substr(1);
		}
		var field = _this2.fields[path];
		if (!field) {
			// TODO: Support arbitary document paths
			console.warn('Invalid Sort specified:', path);
			return;
		}
		return {
			field: field,
			type: field.type,
			label: field.label,
			path: field.path,
			invert: invert
		};
	}).filter(truthy);
	return sort;
};

/**
 * Load a specific item via the API
 *
 * @param  {String}   itemId   The id of the item we want to load
 * @param  {Object}   options
 * @param  {Function} callback
 */
List.prototype.loadItem = function (itemId, options, callback) {
	if (arguments.length === 2 && typeof options === 'function') {
		callback = options;
		options = null;
	}
	var url = KAdm.adminCore + '/api/' + this.path + '/' + itemId;
	var query = qs.stringify(options);
	if (query.length) url += '?' + query;
	xhr({
		url: url,
		responseType: 'json'
	}, function (err, resp, data) {
		if (err) return callback(err);
		// Pass the data as result or error, depending on the statusCode
		if (resp.statusCode === 200) {
			callback(null, data);
		} else {
			callback(data);
		}
	});
};

/**
 * Load all items of a list, optionally passing objects to build a query string
 * for sorting or searching
 *
 * @param  {Object}   options
 * @param  {Function} callback
 */
List.prototype.loadItems = function (options, callback) {
	var url = KAdm.adminCore + '/api/' + this.path + buildQueryString(options);
	xhr({
		url: url,
		responseType: 'json'
	}, function (err, resp, data) {
		if (err) callback(err);
		// Pass the data as result or error, depending on the statusCode
		if (resp.statusCode === 200) {
			callback(null, data);
		} else {
			callback(data);
		}
	});
};

/**
 * Constructs a download URL to download a list with the current sorting, filtering,
 * selection and searching options
 *
 * @param  {Object} options
 *
 * @return {String}         The download URL
 */
List.prototype.getDownloadURL = function (options) {
	var url = KAdm.adminCore + '/api/' + this.path;
	var parts = [];
	if (options.format !== 'json') {
		options.format = 'csv';
	}
	parts.push(options.search ? 'search=' + options.search : '');
	parts.push(options.filters.length ? 'filters=' + JSON.stringify(getFilters(options.filters)) : '');
	parts.push(options.columns ? 'select=' + options.columns.map(function (i) {
		return i.path;
	}).join(',') : '');
	parts.push(options.sort ? 'sort=' + getSortString(options.sort) : '');
	parts.push('expandRelationshipFields=true');
	return url + '/export.' + options.format + '?' + parts.filter(truthy).join('&');
};

/**
 * Delete a specific item via the API
 *
 * @param  {String}   itemId   The id of the item we want to delete
 * @param  {Function} callback
 */
List.prototype.deleteItem = function (itemId, callback) {
	this.deleteItems([itemId], callback);
};

/**
 * Delete multiple items at once via the API
 *
 * @param  {Array}   itemIds  An array of ids of items we want to delete
 * @param  {Function} callback
 */
List.prototype.deleteItems = function (itemIds, callback) {
	// const url = KAdm.adminPath + '/api/' + this.path;
	var url = KAdm.adminCore + '/api/' + this.path + '/delete';
	xhr({
		url: url,
		method: 'POST',
		headers: _.assign({}, KAdm.csrf.header),
		json: {
			ids: itemIds
		}
	}, function (err, resp, body) {
		if (err) return callback(err);
		// Pass the body as result or error, depending on the statusCode
		if (resp.statusCode === 200) {
			callback(null, body);
		} else {
			callback(body);
		}
	});
};

List.prototype.reorderItems = function (item, oldSortOrder, newSortOrder, pageOptions, callback) {
	var url = KAdm.adminPath + '/api/' + this.path + '/' + item.id + '/sortOrder/' + oldSortOrder + '/' + newSortOrder + '/' + buildQueryString(pageOptions);
	xhr({
		url: url,
		method: 'POST',
		headers: KAdm.csrf.header
	}, function (err, resp, body) {
		if (err) return callback(err);
		try {
			body = JSON.parse(body);
		} catch (e) {
			console.log('Error parsing results json:', e, body);
			return callback(e);
		}
		// Pass the body as result or error, depending on the statusCode
		if (resp.statusCode === 200) {
			callback(null, body);
		} else {
			callback(body);
		}
	});
};

module.exports = List;

},{"list-to-array":undefined,"lodash":undefined,"qs":undefined,"xhr":undefined}],13:[function(require,module,exports){
'use strict';
/* eslint-disable no-unused-vars */
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (e) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

module.exports = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (Object.getOwnPropertySymbols) {
			symbols = Object.getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

},{}],14:[function(require,module,exports){
(function (process){
// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// resolves . and .. elements in a path array with directory names there
// must be no slashes, empty elements, or device names (c:\) in the array
// (so also no leading and trailing slashes - it does not distinguish
// relative and absolute paths)
function normalizeArray(parts, allowAboveRoot) {
  // if the path tries to go above the root, `up` ends up > 0
  var up = 0;
  for (var i = parts.length - 1; i >= 0; i--) {
    var last = parts[i];
    if (last === '.') {
      parts.splice(i, 1);
    } else if (last === '..') {
      parts.splice(i, 1);
      up++;
    } else if (up) {
      parts.splice(i, 1);
      up--;
    }
  }

  // if the path is allowed to go above the root, restore leading ..s
  if (allowAboveRoot) {
    for (; up--; up) {
      parts.unshift('..');
    }
  }

  return parts;
}

// Split a filename into [root, dir, basename, ext], unix version
// 'root' is just a slash, or nothing.
var splitPathRe =
    /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
var splitPath = function(filename) {
  return splitPathRe.exec(filename).slice(1);
};

// path.resolve([from ...], to)
// posix version
exports.resolve = function() {
  var resolvedPath = '',
      resolvedAbsolute = false;

  for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
    var path = (i >= 0) ? arguments[i] : process.cwd();

    // Skip empty and invalid entries
    if (typeof path !== 'string') {
      throw new TypeError('Arguments to path.resolve must be strings');
    } else if (!path) {
      continue;
    }

    resolvedPath = path + '/' + resolvedPath;
    resolvedAbsolute = path.charAt(0) === '/';
  }

  // At this point the path should be resolved to a full absolute path, but
  // handle relative paths to be safe (might happen when process.cwd() fails)

  // Normalize the path
  resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function(p) {
    return !!p;
  }), !resolvedAbsolute).join('/');

  return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
};

// path.normalize(path)
// posix version
exports.normalize = function(path) {
  var isAbsolute = exports.isAbsolute(path),
      trailingSlash = substr(path, -1) === '/';

  // Normalize the path
  path = normalizeArray(filter(path.split('/'), function(p) {
    return !!p;
  }), !isAbsolute).join('/');

  if (!path && !isAbsolute) {
    path = '.';
  }
  if (path && trailingSlash) {
    path += '/';
  }

  return (isAbsolute ? '/' : '') + path;
};

// posix version
exports.isAbsolute = function(path) {
  return path.charAt(0) === '/';
};

// posix version
exports.join = function() {
  var paths = Array.prototype.slice.call(arguments, 0);
  return exports.normalize(filter(paths, function(p, index) {
    if (typeof p !== 'string') {
      throw new TypeError('Arguments to path.join must be strings');
    }
    return p;
  }).join('/'));
};


// path.relative(from, to)
// posix version
exports.relative = function(from, to) {
  from = exports.resolve(from).substr(1);
  to = exports.resolve(to).substr(1);

  function trim(arr) {
    var start = 0;
    for (; start < arr.length; start++) {
      if (arr[start] !== '') break;
    }

    var end = arr.length - 1;
    for (; end >= 0; end--) {
      if (arr[end] !== '') break;
    }

    if (start > end) return [];
    return arr.slice(start, end - start + 1);
  }

  var fromParts = trim(from.split('/'));
  var toParts = trim(to.split('/'));

  var length = Math.min(fromParts.length, toParts.length);
  var samePartsLength = length;
  for (var i = 0; i < length; i++) {
    if (fromParts[i] !== toParts[i]) {
      samePartsLength = i;
      break;
    }
  }

  var outputParts = [];
  for (var i = samePartsLength; i < fromParts.length; i++) {
    outputParts.push('..');
  }

  outputParts = outputParts.concat(toParts.slice(samePartsLength));

  return outputParts.join('/');
};

exports.sep = '/';
exports.delimiter = ':';

exports.dirname = function(path) {
  var result = splitPath(path),
      root = result[0],
      dir = result[1];

  if (!root && !dir) {
    // No dirname whatsoever
    return '.';
  }

  if (dir) {
    // It has a dirname, strip trailing slash
    dir = dir.substr(0, dir.length - 1);
  }

  return root + dir;
};


exports.basename = function(path, ext) {
  var f = splitPath(path)[2];
  // TODO: make this comparison case-insensitive on windows?
  if (ext && f.substr(-1 * ext.length) === ext) {
    f = f.substr(0, f.length - ext.length);
  }
  return f;
};


exports.extname = function(path) {
  return splitPath(path)[3];
};

function filter (xs, f) {
    if (xs.filter) return xs.filter(f);
    var res = [];
    for (var i = 0; i < xs.length; i++) {
        if (f(xs[i], i, xs)) res.push(xs[i]);
    }
    return res;
}

// String.prototype.substr - negative index don't work in IE8
var substr = 'ab'.substr(-1) === 'b'
    ? function (str, start, len) { return str.substr(start, len) }
    : function (str, start, len) {
        if (start < 0) start = str.length + start;
        return str.substr(start, len);
    }
;

}).call(this,require('_process'))
},{"_process":15}],15:[function(require,module,exports){
// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };

},{}],"kadm-redux-mng":[function(require,module,exports){
'use strict';

var _redux = require('redux');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _store = require('./App/store');

var _store2 = _interopRequireDefault(_store);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function PluginReduxManager(store) {
    this.pluginRoutes = [];
    this.store = store;
}
PluginReduxManager.prototype.concatRoutes = function (routes) {
    this.pluginRoutes = _lodash2.default.concat(this.pluginRoutes, routes);
};
PluginReduxManager.prototype.addReducers = function (reducers) {
    _lodash2.default.assign(this.store.reducerMap, reducers);
    var combins = (0, _redux.combineReducers)(this.store.reducerMap, reducers);
    this.store.replaceReducer(combins);
};
PluginReduxManager.prototype.getRoutes = function () {
    return this.pluginRoutes;
};
PluginReduxManager.prototype.getStore = function () {
    return this.store;
};

exports = module.exports = new PluginReduxManager(_store2.default);

},{"./App/store":11,"lodash":undefined,"redux":undefined}]},{},[]);
