require=(function(){function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s}return e})()({1:[function(require,module,exports){
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _xhr = require('xhr');

var _xhr2 = _interopRequireDefault(_xhr);

var _Alert = require('./components/Alert');

var _Alert2 = _interopRequireDefault(_Alert);

var _Brand = require('./components/Brand');

var _Brand2 = _interopRequireDefault(_Brand);

var _UserInfo = require('./components/UserInfo');

var _UserInfo2 = _interopRequireDefault(_UserInfo);

var _LoginForm = require('./components/LoginForm');

var _LoginForm2 = _interopRequireDefault(_LoginForm);

var _antdlib = require('antdlib');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * The actual Sign In view, with the login form
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var SigninView = function (_React$Component) {
	_inherits(SigninView, _React$Component);

	function SigninView(props) {
		_classCallCheck(this, SigninView);

		var _this = _possibleConstructorReturn(this, (SigninView.__proto__ || Object.getPrototypeOf(SigninView)).call(this, props));

		_this.state = {
			email: '',
			password: '',
			isAnimating: false,
			isInvalid: false,
			invalidMessage: '',
			signedOut: window.location.search === '?signedout'
		};
		return _this;
	}

	_createClass(SigninView, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			// Focus the email field when we're mounted
			if (this.refs.email) {
				_reactDom2.default.findDOMNode(this.refs.email).select();
			}
		}
	}, {
		key: 'handleInputChange',
		value: function handleInputChange(e) {
			// Set the new state when the input changes
			var newState = {};
			newState[e.target.name] = e.target.value;
			this.setState(newState);
		}
	}, {
		key: 'handleSubmit',
		value: function handleSubmit(e) {
			var _this2 = this;

			e.preventDefault();
			// If either password or mail are missing, show an error
			if (!this.state.email || !this.state.password) {
				return this.displayError('Please enter an email address and password to sign in.');
			}

			(0, _xhr2.default)({
				url: Keystone.adminPath + '/api/session/signin',
				method: 'post',
				json: {
					email: this.state.email,
					password: this.state.password
				},
				headers: (0, _objectAssign2.default)({}, Keystone.csrf.header)
			}, function (err, resp, body) {
				if (err || body && body.error) {
					return body.error === 'invalid csrf' ? _this2.displayError('Something went wrong; please refresh your browser and try again.') : _this2.displayError('The email and password you entered are not valid.');
				} else {
					// Redirect to where we came from or to the default admin path
					if (Keystone.redirect) {
						top.location.href = Keystone.redirect;
					} else {
						top.location.href = _this2.props.from ? _this2.props.from : Keystone.adminPath;
					}
				}
			});
		}
		/**
   * Display an error message
   *
   * @param  {String} message The message you want to show
   */

	}, {
		key: 'displayError',
		value: function displayError(message) {
			this.setState({
				isAnimating: true,
				isInvalid: true,
				invalidMessage: message
			});
			// setTimeout(this.finishAnimation, 750);
		}
		// Finish the animation and select the email field
		// finishAnimation () {
		// 	// TODO isMounted was deprecated, find out if we need this guard
		// 	if (!this.isMounted()) return;
		// 	if (this.refs.email) {
		// 		ReactDOM.findDOMNode(this.refs.email).select();
		// 	}
		// 	this.setState({
		// 		isAnimating: false,
		// 	});
		// }

	}, {
		key: 'render',
		value: function render() {
			var boxClassname = (0, _classnames2.default)('auth-box', {
				'auth-box--has-errors': this.state.isAnimating
			});
			return _react2.default.createElement(
				'div',
				{ className: 'auth-wrapper' },
				_react2.default.createElement(_Alert2.default, {
					isInvalid: this.state.isInvalid,
					signedOut: this.state.signedOut,
					invalidMessage: this.state.invalidMessage
				}),
				_react2.default.createElement('br', null),
				_react2.default.createElement(
					_antdlib.Card,
					{ className: boxClassname },
					_react2.default.createElement(
						'h1',
						{ className: 'u-hidden-visually' },
						this.props.brand ? this.props.brand : 'Keystone',
						' Sign In '
					),
					_react2.default.createElement(
						'div',
						{ className: 'auth-box__inner' },
						_react2.default.createElement(_Brand2.default, {
							logo: this.props.logo,
							brand: this.props.brand
						}),
						this.props.user ? _react2.default.createElement(_UserInfo2.default, {
							adminPath: Keystone.adminPath,
							signoutPath: Keystone.adminPath + '/signout',
							userCanAccessKeystone: this.props.userCanAccessKeystone,
							userName: this.props.user.name.first
						}) : _react2.default.createElement(_LoginForm2.default, {
							email: this.state.email,
							handleInputChange: this.handleInputChange.bind(this),
							handleSubmit: this.handleSubmit.bind(this),
							isAnimating: this.state.isAnimating,
							password: this.state.password
						})
					)
				),
				_react2.default.createElement(
					'div',
					{ className: 'auth-footer' },
					_react2.default.createElement(
						'span',
						null,
						'Powered by '
					),
					_react2.default.createElement(
						'a',
						{ href: '#', title: 'The Node.js CMS and web application platform' },
						'KAdm'
					)
				)
			);
		}
	}]);

	return SigninView;
}(_react2.default.Component);

module.exports = SigninView;

},{"./components/Alert":2,"./components/Brand":3,"./components/LoginForm":4,"./components/UserInfo":5,"antdlib":undefined,"classnames":undefined,"object-assign":6,"react":undefined,"react-dom":undefined,"xhr":undefined}],2:[function(require,module,exports){
'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antdlib = require('antdlib');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Renders an Alert. Pass either an isInvalid and invalidMessage prop, or set
 * the signedOut prop to true to show the standard signed out message
 */

var AlertView = function AlertView(props) {
	if (props.isInvalid) {
		return _react2.default.createElement(_antdlib.Alert, { key: 'error', type: 'danger', showIcon: true, closable: true, message: props.invalidMessage });
	} else if (props.signedOut) {
		return _react2.default.createElement(_antdlib.Alert, { key: 'signed-out', type: 'info', showIcon: true, closable: true, message: '\u6210\u529F\u767B\u51FA' });
	} else {
		// Can't return "null" from stateless components
		return _react2.default.createElement('span', null);
	}
};

AlertView.propTypes = {
	invalidMessage: _react2.default.PropTypes.string,
	isInvalid: _react2.default.PropTypes.bool,
	signedOut: _react2.default.PropTypes.bool
};

module.exports = AlertView;

},{"antdlib":undefined,"react":undefined}],3:[function(require,module,exports){
'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Brand = function Brand(props) {
	// Default to the KeystoneJS logo
	var logo = { src: KAdm.adminPath + '/images/logo.png', width: 205, height: 68 };
	if (props.logo) {
		// If the logo is set to a string, it's a direct link
		logo = typeof props.logo === 'string' ? { src: props.logo } : props.logo;
		// Optionally one can specify the logo as an array, also stating the
		// wanted width and height of the logo
		// TODO: Deprecate this
		if (Array.isArray(logo)) {
			logo = { src: logo[0], width: logo[1], height: logo[2] };
		}
	}
	return _react2.default.createElement(
		'div',
		{ className: 'auth-box__col' },
		_react2.default.createElement(
			'div',
			{ className: 'auth-box__brand' },
			_react2.default.createElement(
				'a',
				{ href: '/', className: 'auth-box__brand__logo' },
				_react2.default.createElement('img', {
					src: logo.src,
					width: logo.width ? logo.width : null,
					height: logo.height ? logo.height : null,
					alt: props.brand
				})
			)
		)
	);
}; /**
    * Renders a logo, defaulting to the Keystone logo if no brand is specified in
    * the configuration
    */

module.exports = Brand;

},{"react":undefined}],4:[function(require,module,exports){
'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antdlib = require('antdlib');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import { Button, Form, FormField, FormInput } from '../../App/elemental';

/**
 * The login form of the signin screen
 */

var LoginForm = function LoginForm(_ref) {
	var email = _ref.email,
	    handleInputChange = _ref.handleInputChange,
	    handleSubmit = _ref.handleSubmit,
	    isAnimating = _ref.isAnimating,
	    password = _ref.password;

	return _react2.default.createElement(
		'div',
		{ className: 'auth-box__col' },
		_react2.default.createElement(
			_antdlib.Form,
			{ onSubmit: handleSubmit },
			_react2.default.createElement(
				_antdlib.Form.Item,
				{ label: 'Email', htmlFor: 'email' },
				_react2.default.createElement(_antdlib.Input, {
					size: 'large',
					autoFocus: true,
					type: 'email',
					name: 'email',
					onChange: handleInputChange,
					value: email
				})
			),
			_react2.default.createElement(
				_antdlib.Form.Item,
				{ label: 'Password', htmlFor: 'password' },
				_react2.default.createElement(_antdlib.Input, {
					size: 'large',
					type: 'password',
					name: 'password',
					onChange: handleInputChange,
					value: password
				})
			),
			_react2.default.createElement(
				_antdlib.Button,
				{ type: 'primary', size: 'large', htmlType: 'submit' },
				'\u767B\u5F55'
			)
		)
	);
};

LoginForm.propTypes = {
	email: _react.PropTypes.string,
	handleInputChange: _react.PropTypes.func.isRequired,
	handleSubmit: _react.PropTypes.func.isRequired,
	isAnimating: _react.PropTypes.bool,
	password: _react.PropTypes.string
};

module.exports = LoginForm;

},{"antdlib":undefined,"react":undefined}],5:[function(require,module,exports){
'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antdlib = require('antdlib');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO Figure out if we should change "Keystone" to "Admin area"

var UserInfo = function UserInfo(_ref) {
	var adminPath = _ref.adminPath,
	    signoutPath = _ref.signoutPath,
	    userCanAccessKeystone = _ref.userCanAccessKeystone,
	    userName = _ref.userName;

	var adminButton = _react2.default.createElement(
		_antdlib.Button,
		{ size: 'large', href: adminPath, type: 'primary' },
		'Open KAdm'
	);

	return _react2.default.createElement(
		'div',
		null,
		_react2.default.createElement(
			'p',
			null,
			'Hi ',
			userName,
			','
		),
		_react2.default.createElement(
			'p',
			null,
			'\u4F60\u5DF2\u7ECF\u767B\u5F55.'
		),
		_react2.default.createElement(
			'div',
			{ style: {
					display: 'flex',
					justifyContent: 'space-between'
				} },
			adminButton,
			_react2.default.createElement(
				_antdlib.Button,
				{ size: 'large', href: signoutPath, type: 'link-cancel' },
				'\u767B\u51FA'
			)
		)
	);
};
// import { Button } from '../../App/elemental';


UserInfo.propTypes = {
	adminPath: _react.PropTypes.string.isRequired,
	signoutPath: _react.PropTypes.string.isRequired,
	userCanAccessKeystone: _react.PropTypes.bool,
	userName: _react.PropTypes.string.isRequired
};

module.exports = UserInfo;

},{"antdlib":undefined,"react":undefined}],6:[function(require,module,exports){
'use strict';
/* eslint-disable no-unused-vars */
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (e) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

module.exports = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (Object.getOwnPropertySymbols) {
			symbols = Object.getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

},{}],"Signin":[function(require,module,exports){
'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Signin = require('./Signin');

var _Signin2 = _interopRequireDefault(_Signin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_reactDom2.default.render(_react2.default.createElement(_Signin2.default, {
	brand: Keystone.brand,
	from: Keystone.from,
	user: Keystone.user,
	userCanAccessKeystone: Keystone.userCanAccessKeystone
}), document.getElementById('signin-view')); /**
                                              * The signin page, it renders a page with a username and password input form.
                                              *
                                              * This is decoupled from the main app (in the "App/" folder) because we inject
                                              * lots of data into the other screens (like the lists that exist) that we don't
                                              * want to have injected here, so this is a completely separate route and template.
                                              */

},{"./Signin":1,"react":undefined,"react-dom":undefined}]},{},["Signin"]);
