/**
 * Created by kinfen on 16/1/27.
 * 处理所有静态路由
 */

var	express = require('express');
var path = require('path');
var kadm = require('../../../');
var _ = require('lodash');

exports = module.exports = function() {
	var routes = express.Router();
	
	
	routes.use(express.static(path.resolve(__dirname, "../../client/public")));
	_.forEach(kadm.getAdminPlus().get('plugins'), (o) => {
		var pluginPath = o.getWebPluginPath();
		if (pluginPath){
			let queryPath = path.join('/', o.getName());
			routes.use(queryPath, express.static(pluginPath));
		}
		
	})
	return routes;
};
