var babelify = require('babelify');
var browserify = require('browserify');
var uglify = require('./uglifystream');
var path = require('path');
var str = require('string-to-stream');
var basedir = path.resolve(__dirname + '/../admin/client/');
var b = browserify({
	basedir,
});
b = b.transform(babelify);
b.exclude('FieldTypes');
b.exclude('antdlib');
b.exclude('KCms');
b.exclude('kadm-redux-mng');
var packages = require('../admin/client/prebuild/packages');
b.require('./output.js', {expose:"kadm-component"});


packages.forEach(function (i) {
	b.exclude(i);
});

if (process.env.NODE_ENV === 'production'){
	uglify(b).pipe(process.stdout);
} else {
	b.bundle().pipe(process.stdout);
}
