/**
 * Created by kinfen on 2016/12/27.
 */




var path = require('path');
var kadm = require('../');
var keystone = kadm.getAdminPlus();
function requireKeystoneFields (fieldTypes) {
	var src = '';
	var types = Object.keys(fieldTypes);
	var map = {};

	['Column', 'Field', 'Filter'].forEach(function (i) {
		map[i] = {};
		types.forEach(function (type) {
			if (typeof fieldTypes[type] !== 'string') return;

			map[i][type] = `require('../../fields/types/${type}/${fieldTypes[type]}${i}'),\n`

		});
	});
	return map;
}

var map = requireKeystoneFields(kadm.fieldTypes);
module.exports = exports = map;
