import Touchable from '../Field';

// TODO consider how toe remove bootstrap
//import {
//	OverlayTrigger,
//	Popover,
//	Glyphicon,
//	ButtonGroup,
//	Button,
//} from 'react-bootstrap'

import {
	Button,
	Popover,
	Icon,
} from 'antdlib';
import React from 'react';
import {IconType} from './config';

module.exports = Touchable.create({
	displayName: 'AntdsIcon',
	statics: {
		type: 'antdsicon',

	},
	componentWillMount(){
		this.state = {
			icon:this.props.value,
			defaultIcon:this.props.value,
			popup:false,
		}
	},
	componentDidMount(){
		// console.log(this.refs.btn)
		// $(this.refs.btn).popover();
		// $('[data-toggle="popover"]').popover();
	},
	handleClick(e){


		var str = $(e.currentTarget).data('icon');

		const name = this.getInputName(this.props.path);
		this.props.form.setFieldsValue({
			[name]:str
		})

		this.setState({
			//icon:str,
			popup:false,
		});

	},

	renderCssBtns(icon){

		let classStr = [""].concat(IconType);
		let glyphs = _.map(classStr, (str) => {
			if (str == "")
				return <Button size="large" type="default" shape="circle" data-icon="" onClick={this.handleClick.bind(this)}>
					<i>&nbsp;</i>
				</Button>
			else
				return (
						<Button size="large" type="default" shape="circle" icon={str} data-icon={str} onClick={this.handleClick.bind(this)} />
					)
		});
		const content = (<div className="fields-glyphicon-popover-container">

			{glyphs}

		</div>);

		var handleVisibleChange = (visible) => {
			this.setState({ popup:visible });
		}

		return (

			<Popover content={content}
					 title="请选择一个icon"
					 trigger="click"
					 size="large"
					 onVisibleChange = {handleVisibleChange}
					 visible={this.state.popup}
			>
				<Button size="large" type="default" shape="circle" icon={icon} />
			</Popover>
		)
	},
	renderField () {
		const { autoFocus, value, inputProps } = this.props;
		const name = this.getInputName(this.props.path);
		const icon = this.props.form.getFieldValue(name);
		return (
			<div>
				{this.renderCssBtns(icon)}
				<input
					name={this.getInputName(this.props.path)}
					type="hidden"
				/>
			</div>
		);
	},
	renderValue () {
		return <Icon icon={this.props.value}/>
		// return <FormInput noedit>{this.props.value}</FormInput>;
	},
});
