import React from 'react';
import {
	Link,
} from 'react-router';

var TextColumn = React.createClass({
	displayName: 'TextColumn',
	propTypes: {
		col: React.PropTypes.object,
		data: React.PropTypes.object,
		linkTo: React.PropTypes.string,
	},
	getValue () {
		// cropping text is important for textarea, which uses this column
		const value = this.props.data.fields[this.props.col.path];
		return value ? value.substr(0, 100) : null;
	},
	render () {
		const value = this.getValue();
		const linked = this.props.linkTo ? true : false;
		const LinkNode = linked ? (<Link to={this.props.linkTo}>
			{value}
		</Link>) : (<div>
			{value}
		</div>);
		return (
			<div>
				{LinkNode}
			</div>
		);
	},
});
/**
<ItemsTableCell>
	<ItemsTableValue className={className} to={this.props.linkTo} empty={empty} padded interior field={this.props.col.type}>
		{value}
	</ItemsTableValue>
</ItemsTableCell>
 */
module.exports = TextColumn;
