import Field from '../Field';
import React from 'react';

import {Input} from "antdlib";
const {TextArea} = Input;
module.exports = Field.create({
	displayName: 'TextareaField',
	statics: {
		type: 'Textarea',
	},
	handlePressEnter(){
		console.log('enter press')
	},
	renderField () {
		// const { path } = this.props;
		// var props = _.assign({}, this.props);
		const {autosize, path} = this.props;
		return (
			<TextArea
				{
					...{
						autosize,
						onPressEnter:this.handlePressEnter.bind(this),
						autoComplete:"off",
						name:this.getInputName(path),
					}

				}

			/>
		);
	},
});
