var kadm = require("../");
var _ = require("lodash");
var fields = kadm.getAdminPlus().Field.Types;
var path = require("path");

fields = _.assign(
	{},
	{
		/**
		 *  self defined fields
		 *
		 */
		get GlyphsIcon () { return require('../fields/types/glyphsicon/GlyphsIconType')},
		get AntdsIcon () { return require('../fields/types/antdsicon/AntdsIconType')},


		/**
		 *  override the keystone fields, belows we have redefinee it with ant designs
		 *
		 */

		//becoause of the time format need to be set myself, so we redirect the datetime referencee to my own.
		get Boolean () { return require('../fields/types/boolean/BooleanType'); },
		get Number () { return require('../fields/types/number/NumberType'); },
		get Html () { return require('../fields/types/html/HtmlType'); },
		get Code () { return require('../fields/types/code/CodeType'); },
		get Text () { return require('../fields/types/text/TextType'); },
		get Select () { return require('../fields/types/select/SelectType'); },
		get ModuleSelect () { return require('../fields/types/moduleselect/ModuleSelectType');},
		get Relationship () { return require('../fields/types/relationship/RelationshipType'); },
		get Textarea () { return require('../fields/types/textarea/TextareaType'); },
		get Datetime () { return require('../fields/types/datetime/DatetimeType');},
		get Password () { return require('../fields/types/password/PasswordType');},
		get Name () { return require('../fields/types/name/NameType');},
		get Key () { return require('../fields/types/key/KeyType');},
		get File () { return require('../fields/types/file/FileType');},
		get Color () { return require('../fields/types/color/ColorType');},
		get Url () { return require('../fields/types/url/UrlType');},
		get Email () { return require('../fields/types/email/EmailType');},
		get QRCode () { return require('../fields/types/qrcode/QRCodeType');},
		
		//for control column, with no visible field
		get Control () { return require('../fields/types/control/ControlType');},
	}
)
delete fields.CloudinaryImage;
delete fields.CloudinaryImages;
module.exports = fields;
