/**
 * Created by kinfen on 2017/8/4.
 */
var express = require('express');
var path = require('path');
var ejs = require('ejs');
var app = express();
var browserify = require('../admin/client/prebuild/middleware/browserify');
var less = require('less-middleware');
var routerFun = function () {
	var router = express.Router();
	/* Prepare browserify bundles */
	var bundles = {
		// test: browserify('App/test/layout.js'),
		test: browserify('App/test/picker.js'),
	};


	bundles.test.build();

    //
	///* Prepare LESS options */
	////var lessPaths = keystone.get('less');
	////var lessOptions = keystone.get('less options') || {};
    //
	//var path1 = kadm.getKeystonePath();
	//var path2 = kadm.getKeystoneRelativePath(__dirname);
    //
	//var elementalPath = path.join(path.dirname(require.resolve('elemental')), '..');
	//var reactSelectPath = path.join(path.dirname(require.resolve('react-select')), '..');
	//var keystonePath = kadm.getKeystonePath();
	var antdPath = path.join(path.dirname(require.resolve('antd')), '..');
	var lessOptions = {
		render: {
			modifyVars: {
				//elementalPath: JSON.stringify(elementalPath),
				//reactSelectPath: JSON.stringify(reactSelectPath),
				//adminPath:JSON.stringify(keystone.get('admin path')),
				//keystonePath: JSON.stringify(keystonePath),
				antdPath:JSON.stringify(antdPath),
			}
		},
		debug:true
	};
	//
	///* Configure router */
	router.use('/style', less(path.resolve(__dirname , '../admin/client/public/style'), lessOptions));
	//router.use('/styles/fonts', express.static(path.resolve(__dirname , '../../../public/js/lib/tinymce/skins/keystone/fonts')));
	router.get('/js/test.js', bundles.test.serve);
	const staticPath = path.resolve(__dirname , '../admin/client/public');
	router.use(express.static(staticPath));
	return router;
};

var testhtml = function(req, res){
	var locals = {
		adminPath:"",
	}
	var templatePath = path.resolve(__dirname, 'test.ejs');
	ejs.renderFile(templatePath, locals, {}, function (err, str) {
		if (err) {
			console.error('Could not render Admin UI Index Template:', err);
			return res.status(500).send(err);
		}
		res.send(str);
	});
}
app.use ("/", routerFun());
app.get('/', testhtml);

app.listen(4000, "0.0.0.0", null, function(){
	console.log('prepare html test');
});
