
/**
 * Created by kinfen on 16/9/7.
 */

var kadm = require('../../');
var keystone = kadm.getAdminPlus(),
	Types = kadm.Field.Types;
var config = require('../../config/config');
/**
 * User Model
 * ==========
 */

var Action = new keystone.List('Action', {
	schema:{
		code:{
			unique:true,
		}
	}
});

Action.add({
	name: { label:"操作", type: String,  required: true, initial:true},
	code:{ label:"代码", type: Types.Key, required: true, initial:true , index:true, noedit:true,},
	icon: { label:"图标", type: Types.AntdsIcon},
	enableOnlyWhenSelected:{ label:"选择列表后激活", type: Types.Boolean, default:false},
	ordernum: {label:"排序号", type: Types.Number ,default:0},
	primary:{label:"Primary", type:Types.Boolean, default:false},
	state:{label:"状态", type: Types.Select, numeric:true, options: config.global_states, default:config.GLOBAL_STATE_NORMAL.value },
	description:{label:"描述",  type: Types.Text, default:''},

});

Action.defaultColumns = 'name|100, code, icon, ordernum';
Action.defaultSort = '-ordernum';
Action.register();


