
/**
 * Created by kinfen on 16/9/7.
 */

var kadm = require('../../');
var keystone = kadm.getAdminPlus(),
	Types = kadm.Field.Types;

/**
 * User Model
 * ==========
 */

var UserRole = new keystone.List('UserRole');

UserRole.add({
	name: {label:"用户", type: Types.Relationship, ref: 'User',default:'', required: true, initial:true, noedit:true},
	role: {label:"角色", type: Types.Relationship, ref: 'Role',default:'', many:true,},

});

UserRole.defaultColumns = 'name, role';
UserRole.defaultSort = '-name';
UserRole.register();


