/**
 * Created by kinfen on 16/7/26.
 */

import React from 'react';

var HeadNav = React.createClass({
	
	componentDidMount () {
		
	},
	renderLogoNode(){
		return (
			<a className="logo">
				<span className="logo-mini">
					<b>K</b>
				</span>
				<span className="logo-lg">
					<b>KA</b>
					dmin
				</span>
			</a>
		);
	},
	renderUserPanel(){
		return (
			<ul className="dropdown-menu">
				<li className="user-header">
					<img className="img-circle" src={this.props.adminPath + '/dist/img/user2-160x160.jpg'} alt='User Image'/>
					<p>
						Alexander Pierce - Web Developer
						<small>Member since Nov. 2012</small>
					</p>
				</li>
				<li className="user-body">
					<div className="row">
						<div className=" col-xs-4 text-center">
							<a href="#">Followers</a>
						</div>
						<div className=" col-xs-4 text-center">
							<a href="#">Sales</a>
						</div>
						<div className=" col-xs-4 text-center">
							<a href="#">Friends</a>
						</div>
					</div>
					
				</li>
				<li className="user-footer" href="#">
					<div className="pull-left">
						<a className="btn btn-default btn-flat" href='#'>Profile</a> 
					</div>
					<div className="pull-right">
						<a className="btn btn-default btn-flat" href='#'>Profile</a>
					</div>
				</li>
			</ul>
		);
	},
	renderMessageList(){
		return (
			<ul className="dropdown-menu">
				<li className="header">You have 4 messages</li>
				<li>
					<ul className="menu">
						<li>
							<a href="#">
								<div className="pull-left">
									<img className="img-circle" src={this.props.adminPath + '/dist/img/user2-160x160.jpg'} alt='User Image'/>
								</div>
								<h4>
									Support Team
									<small>
										<i className="fa fa-clock-o">
											5 mins
										</i>
									</small>
								</h4>
								<p>
									Why not buy a new awesome theme?
								</p>
							</a>
						</li>
						<li>
							<a href="#">
								<div className="pull-left">
									<img className="img-circle" src={this.props.adminPath + '/dist/img/user2-160x160.jpg'} alt='User Image'/>
								</div>
								<h4>
									Support Team
									<small>
										<i className="fa fa-clock-o">
											2 hours
										</i>
									</small>
								</h4>
								<p>
									Why not buy a new awesome theme?
								</p>
							</a>
						</li>
						<li>
							<a href="#">
								<div className="pull-left">
									<img className="img-circle" src={this.props.adminPath + '/dist/img/user2-160x160.jpg'} alt='User Image'/>
								</div>
								<h4>
									Support Team
									<small>
										<i className="fa fa-clock-o">
											2 hours
										</i>
									</small>
								</h4>
								<p>
									Why not buy a new awesome theme?
								</p>
							</a>
						</li>
						<li>
							<a href="#">
								<div className="pull-left">
									<img className="img-circle" src={this.props.adminPath + '/dist/img/user2-160x160.jpg'} alt='User Image'/>
								</div>
								<h4>
									Support Team
									<small>
										<i className="fa fa-clock-o">
											2 hours
										</i>
									</small>
								</h4>
								<p>
									Why not buy a new awesome theme?
								</p>
							</a>
						</li>
					</ul>
				</li>
				<li className="footer" href="#">See All Messages</li>
			</ul>
		);
	},
	render () {
		return (
			<header className="main-header">
				{this.renderLogoNode()}
				<nav className="navbar navbar-static-top" role="navigation">
					<a className="sidebar-toggle" href='#' data-toggle='offcanvas' role='button'>
						<span className="sr-only">Toggle navigation</span>
					</a>
					<div className="navbar-custom-menu">
						<ul className="nav navbar-nav">
							<li className="dropdown messages-menu">
								<a className="dropdown-toggle" href='#' data-toggle='dropdown'>
									<i className="fa fa-envelope-o"/>
									<span className="label label-success">4</span>
								</a>
								{this.renderMessageList()}
							</li>
							<li className="dropdown user user-menu">
								<a className="dropdown-toggle" href='#' data-toggle='dropdown'>
									<img className="user-image" src={this.props.adminPath + '/dist/img/user2-160x160.jpg'} alt='User Image'/>
									<span className="hidden-xs">Alexander Pierce</span>
								</a>
								{this.renderUserPanel()}
							</li>
							<li>
								<a href='#' data-toggle='control-sidebar'>
									<i className="fa fa-gears"/>
								</a>
							</li>
						</ul>
					</div>
				</nav>
			</header>
		);
	}
});

module.exports = HeadNav;



