/**
 * Created by kinfen on 2017/5/19.
 */
import React from 'react';
import ReactDOM from 'react-dom';
import _ from "lodash";
import { Fields} from "FieldTypes";
const styleObj = {
	height:300,
	maxHeight:300,
}
import ModuleAppointModal from './ModuleAppointModal';

class ModelAppointModal extends ModuleAppointModal {

	constructor(props){
		super(props);

	}
	get action(){
		return 'setmodel';
	}
	onModuleSelected(e, nodes){
		if (this.props.roles){
			let role = this.props.roles[0];
			if (role && nodes.length > 0){
				let checkAll = this.state.valueMap[nodes[0].id] ? this.state.valueMap[nodes[0].id].length == this.state.actionData.length : false;
				this.setState({
					selectedModuleCode:nodes[0].id,
					indeterminate: this.state.valueMap[nodes[0].id] ? (this.state.valueMap[nodes[0].id].length > 1 && !checkAll) : false,
					checkAll,
				})
			}
			else {
				this.setState({
					selectedModuleCode:null,
				})
			}

		}
	}

	loadAvailModule(cb){
		var lists = [];
		_.forEach(KAdm.lists, function (list, key) {
			lists.push(list);
		});
		cb (null, lists);
	}
	componentDidMount(){

	}

	renderNodesData(list){
		return _.map(list, (o) => {
			return {
				text:o.label,
				id:o.key,
			}
		})
	}


}

export default  ModelAppointModal;
