import React from 'react';
import ReactDOM from 'react-dom';
import _ from 'lodash';
import Component from './KComponent';
import AntModal from 'antd/lib/modal';
import {
	Button,
} from 'antdlib'

class Loading extends Component{
	componentDidMount () {

	}
	render(){
		var node;
		if (this.props.loading)
		{
			node = (
				<div className="loadingSpinner">
					<div className="dot1" />
					<div className="dot2" />
				</div>
			);
		}
		else {
			node = <div/>;
		}

		return node;
	}

};
class Modal extends Component{
	constructor(props) {
		super(props);
		this.state = {
			show:false,
			isNeedUpdate:true,
			type: "",
			title:"",
			body:"",
			leftItems:[],
			rightItems:[{
				name:"关闭",
				style:"default",
				data:"dismiss",
			}],

		};
	}
	componentDidMount () {

	}
	// hiddenHandler(e){
    //
	// 	if (this.state.onHidden){
	// 		this.state.onHidden(e)
	// 	}
	// 	this.setState({
	// 		show:false,
	// 		onHidden:null,
	// 	})
	// }
	componentDidUpdate(){

	}
	// shouldComponentUpdate(nextProps, nextState) {
    //
	// 	// return nextState.show != this.state.show || this.state.show;
	// }
	show(state){
		if (state){
			state.show = true;
			this.setState(state);
		}
	}
	onOk(){

	}
	hide(){
		this.setState({
			show:false,
		});
		if (this.state.onHidden)
		{
			this.state.onHidden();
			delete this.state.onHidden;
		}
	}
	// render(){
    //
    //
	// 	var modalType = "modal-" + this.state.style;
	// 	var body;
	// 	body = typeof this.state.body === "string"
	// 		? (<p>{this.state.body}</p>)
	// 		: this.state.body;
    //
	// 	return body;
	// }
	renderFooter(){
		var footer = [];
		var count = 0;
		var self  = this;

		var footerBtns = {leftItems:this.state.leftItems || [], rightItems:this.state.rightItems || []};

		_.each(footerBtns, (obj, key) => {
			for (var i = 0; i < obj.length; i++)
			{

				var item = obj[i];
				if (item.$$typeof)
				{
					count++;
					footer.push(item);
				}
				else
				{
					var className = "btn btn-" + item.style;
					if (key === "leftItems")
						className += " pull-left";
					var callback = item.onClick;
					if (item.data === "dismiss")
					{

						footer.push(<Button size={item.size}  onClick={this.hide.bind(this)} key={count++}>{item.name}</Button>);
					}
					else
					{
						footer.push(<Button type="primary" size={item.size} onClick={callback} key={count++}>{item.name}</Button>);
					}
				}
			}
		});
		return footer;
	}
	render(){

		if (!this.state.show) return null;

		return (

			<AntModal
				visible={this.state.show}
				title={this.state.title}
				onCancel={this.hide.bind(this)}
				footer={this.renderFooter()}
			>
				{this.state.body}
			</AntModal>
		);

	}
};



class LaddaBtn extends Component {
	constructor(props) {
		super(props)
		this.laddaBtn = null;
		this.state = {
			loading:false,
		};
	}
	componentDidMount(){
		this.setState({
			loading:this.props.state || false,
		})
	}
	onClick(e){
		this.start();
		if (this.props.clickHandler)
		{
			this.props.clickHandler(this, e);
		}

	}
	start(){
		this.setState({
			loading:true,
		})
	}
	stop(){
		this.setState({
			loading:false,
		})
	}
	render(){
		var submit = this.props.submit ? 'submit' : 'button';
		return (
			<Button disabled={this.props.disabled} ref="btn" loading={this.state.loading} size={this.props.size} htmlType={submit} type={this.props.type}  onClick={submit == "submit" ? null : this.onClick.bind(this)}>
				{this.props.children}
			</Button>
		)
	}
	//render(){

	//	var props = {};
	//	var tag = 'button';
	//	props.type = this.props.submit ? 'submit' : 'button';
	//	props.dataStyle = direction;
	//	props.className = classStr;
	//	props.onClick= this.onClick;
	//	if (props.href) {
	//		tag = 'a';
	//		delete props.type;
	//	}
	//	return React.createElement(tag, props, this.props.children);
	//}
};

class Pagination extends Component{
	constructor(props) {
		super(props)
		this.maxPage = 7;
		this.state = {};
	}
	nextPage(){
		if (this.props.onPageWillChangeTo)
		{
			this.props.onPageWillChangeTo(Math.min(this.props.page + 1, this.props.totalPages) );
		}
	}
	prePage(){
		if (this.props.onPageWillChangeTo)
		{
			this.props.onPageWillChangeTo(Math.max(this.props.page - 1, 1) );
		}
	}
	pageSizeSelectedHandler(e){
		var size = $(e.currentTarget).data("size");
		if (this.props.onPageSizeWillChangeTo)
		{
			this.props.onPageSizeWillChangeTo(size);
		}
	}
	pageSelectedHandler(e){
		var page = $(e.currentTarget).data("page");
		if (this.props.onPageWillChangeTo)
		{
			this.props.onPageWillChangeTo(page);
		}
	}
	renderPageSizeSelector(){

		var psList = [10, 25, 50, 100];
		var liList = [];
		for (var i = 0; i < psList.length; i++)
		{
			var size = psList[i];
			liList.push(
				<li onClick={this.pageSizeSelectedHandler.bind(this)} data-size={size} key={i}><a href="javascript:void(0)">{size}</a></li>
			);
		}

		return(
			<div className="pull-left pagination-detail">
				<span className="pagination-info">第{this.props.page}页&nbsp;</span>
				<span className="page-list">
					<span className="btn-group dropup">
						<button type="button" className="btn btn-default  dropdown-toggle" data-toggle="dropdown">
							<span className="page-size">{this.props.pageSize}</span>
							<span className="caret"></span>
						</button>
						<ul className="dropdown-menu" role="menu">
							{liList}
						</ul>
					</span>
				</span>
			</div>
		);
	}
	renderPageSelector(){

		var liList = [];
		var beginIndex;
		var endIndex;
		var page = this.props.page;
		page = Math.max(1, page);
		page = Math.min(this.props.totalPages, page);

		if (this.props.totalPages <= this.maxPage)
		{
			beginIndex = 1;
			endIndex = this.props.totalPages;
			for (var i = beginIndex; i <= endIndex; i++)
			{
				var classStr = i === page? "page-number active" : "page-number";
				liList.push(<li className={classStr} data-page={i} key={i} onClick={this.pageSelectedHandler.bind(this)}><a href="javascript:void(0)">{i}</a></li>);
			}
		}
		else
		{
			var offset = 0;
			var halfPage = Math.floor(this.maxPage / 2);
			beginIndex = page - halfPage;
			endIndex = page + halfPage;
			if (page-halfPage < 1)
			{
				offset = 1 - (page - halfPage);
			}
			else if (page + halfPage > this.props.totalPages)
			{r
				offset = this.props.totalPages - (page + halfPage);
			}
			beginIndex += offset;
			endIndex += offset;
			var keyCounter = 0;
			if (beginIndex > 1)
			{
				beginIndex += 2;
				liList.push(<li className="page-number" onClick={this.pageSelectedHandler.bind(this)} data-page={1} key={1}><a href="javascript:void(0)" >1</a></li>);
				liList.push(<li className="page-last-separator disabled" key={2}><a href="javascript:void(0)">...</a></li>);
			}
			if (endIndex < this.props.totalPages) {
				endIndex -= 2;
			}
			for (var i = beginIndex; i <= endIndex; i++)
			{
				var classStr = i === page? "page-number active" : "page-number";
				liList.push(<li className={classStr} data-page={i} key={i} onClick={this.pageSelectedHandler.bind(this)}><a href="javascript:void(0)">{i}</a></li>);
			}
			if (endIndex < this.props.totalPages)
			{
				liList.push(<li className="page-last-separator disabled" key={this.props.totalPages - 1}><a href="javascript:void(0)">...</a></li>);
				liList.push(
					<li className="page-number" onClick={this.pageSelectedHandler.bind(this)} data-page={this.props.totalPages} key={this.props.totalPages}>
						<a href="javascript:void(0)">{this.props.totalPages}</a>
					</li>);
			}
		}


		return(
			<div className="pull-right pagination">
				<ul className="pagination">
					<li className="page-pre" onClick={this.prePage.bind(this)}><a href="javascript:void(0)" >‹</a></li>
					{liList}
					<li className="page-next" onClick={this.nextPage.bind(this)}><a href="javascript:void(0)" >›</a></li>
				</ul>
			</div>
		);
	}
	render(){
		return (
			<div className="table-pagination">
				{this.renderPageSizeSelector()}
				{this.renderPageSelector()}
			</div>
		);
	}

};

//KAdm.modal = ReactDOM.render(
//	<Modal/>, $("#modal")[0]
//);

class AlertBox extends Component {
	constructor(props){
		super(props);
		this.propTypes = {
			dismissable:true,
			style:"info",
		}
	}
	render(){
		let dimissable = this.props.dimissable || true;
		let style = this.props.style || "primary";
		let classname = ["alert"];
		classname.push("alert-" + style);
		let closeBtn;

		if (dimissable){
			classname.push("alert-" + dimissable);
			closeBtn = <button type="button" className="close" data-dismiss="alert" aria-hidden="true">×</button>
		}
		if (this.props.className){
			classname.push(this.props.className);
		}

		return (
			<div className={classname.join(" ")}>
				{closeBtn}
				<h4><i class="icon fa fa-ban"></i>{this.props.title}</h4>
				{this.props.message}
			</div>
		)
	}
}

export {
	Loading,
	Modal,
	LaddaBtn,
	Pagination,
	AlertBox
}
