/**
 * Created by kinfen on 16/7/27.
 */
import _ from 'lodash';
import {
	APP_SIDE_BAR_LOADED,
	APP_SHOW_MAIN_LOADING,
	APP_LOAD_CURRENT_USER,
	APP_MODULE_SELECTED,
} from './action';

const initialState = {
	modules:{},
	lists:{},
	mainloading:false,
	selectedModule:null,
};

function reducer (state = initialState, action) {
	switch (action.type) {
		case APP_SIDE_BAR_LOADED:
			return _.assign({}, state, {
				modules: action.modules,
			});
		case APP_SHOW_MAIN_LOADING:
			return _.assign({}, state, {
				mainloading: action.mainloading,
			});

		case APP_LOAD_CURRENT_USER:
			return _.assign({}, state, {
				user: action.user,
			});
		case APP_MODULE_SELECTED:
			return _.assign({}, state, {
				selectedModule: action.selectedModule,
			});
		default:
			return state;
	}
}
export default reducer;
