/**
 * Created by kinfen on 16/7/26.
 */

var controlAPI = function(opt, isNeedCsrfVaild, cb)
{
	if (isNeedCsrfVaild)
	{
		var key = "x-csrf-token";
		opt.beforeSend=function(req) {
			req.setRequestHeader(key, KAdm.csrf.header[key]);
		};
		//opt.data[KAdm.csrf.key] = KAdm.csrf.value;
	}
	if (!opt.success && !opt.error){
		if (cb){
			opt.success = (data)=>{
				cb(null, data);
			}
			opt.error = (xhr, error)=>{
				cb(xhr.responseJSON, null);
			}
		}
	}
	$.ajax(opt);
}

export const INNERAPP_MODULE_LOADED = "INNERAPP_MODULE_LOADED";

export function loadInnerMenus(module){
	return (dispatch, getState) => {

		var self = this;
		controlAPI({
			url:KAdm.adminPath + '/api2/AppModule/tree',
			data:{
				module,
			},
			method:'GET',
			dataType:'json',
		}, true, (err, data) => {
			if (err) return;

			dispatch({
				type:INNERAPP_MODULE_LOADED,
				modules:data.list
			})
		});
	}
}

export const INNERAPP_MODULE_SELECTED = "INNERAPP_MODULE_SELECTED";
export function selecteModule (selectedModule) {
	return {
		type: INNERAPP_MODULE_SELECTED,
		selectedModule,
	};
}

export const INNERAPP_MODULE_FILTERS = "INNERAPP_MODULE_FILTERS";
export function initListFilters (filter, value) {
	return {
		type: INNERAPP_MODULE_FILTERS,
		filter:{
			filter,
			value,
		}
	};
}

