import React from 'react';
import { connect } from 'react-redux';
import path from 'path';
import {
    components,
	actions
} from 'kadm-component';
import reduxManager from "kadm-redux-mng";
var store = reduxManager.getStore();

var {
    clearContent,
    selectModel,
    selectList,
} = actions.lists;

var {
    setActiveList,
    setFilter,
    setActiveSort,
} = actions.active;

var {
	ListView,
	KComponent,
} = components;


class InnerList extends KComponent {

    constructor(props){
		super(props);
		
		this.sortName = null;
		this.sortOrder = null;
		this.innerContent = null;

    }
    componentWillReceiveProps(nextProps){
		if (nextProps.params.model != this.props.params.model){
			store.dispatch(clearContent());
			store.dispatch(selectModel(nextProps.params.model));
		}
	}
    componentWillMount(){
		this.props.dispatch(selectModel(this.props.params.model));
    }
    componentwillre
    render(){

        
        
        return <ListView
                    ref="cateContent"
                    apiPath="api2"
                    title={this.props.selectedModule ? this.props.selectedModule.name : ""}
                    isNeedCreateParams={true}
                    initFilter={this.props.initFilter}
                    itemUrlPrefix={path.join('/', KAdm.adminPath, 'innerapp', this.props.params.app, this.props.params.appid)}
                    columns={this.props.columns}
                    store={store}
                />
    }
}

export {
	InnerList
}
export default connect((state) => {
	return {
		catid:state.listca.nodeid,
		loading:state.lists.loading,
        columns:state.active.columns,
        initFilter:state.innerapp.filter,
        currentModel:state.lists.currentModel,
	}
})(InnerList)