/**
 * Created by kinfen on 16/7/26.
 */
import _ from 'lodash';
import {
	INNERAPP_MODULE_LOADED,
	INNERAPP_MODULE_SELECTED,
	INNERAPP_MODULE_FILTERS
} from './actions'
const initialState = {
	modules:null,
	selectedModule:null,
	filter:null,
};

function innerapp (state = initialState, action) {
	switch (action.type) {
		case INNERAPP_MODULE_LOADED:
			return _.assign({}, state, {
				modules: action.modules,
			});
		case INNERAPP_MODULE_SELECTED:
			return _.assign({}, state, {
				selectedModule: action.selectedModule,
			});
		case INNERAPP_MODULE_FILTERS:
			return _.assign({}, state, {
				filter: action.filter,
			});
		default:
			return state;
	}
}

export default innerapp;
