import React, { PropTypes } from 'react';
// import { Button } from '../../App/elemental';
import {
	Button
} from 'antdlib'
// TODO Figure out if we should change "Keystone" to "Admin area"

const UserInfo = ({
	adminPath,
	signoutPath,
	userCanAccessKeystone,
	userName,
}) => {
	const adminButton = (
		<Button size="large" href={adminPath} type="primary">
			Open KAdm
		</Button>
	);

	return (
		<div>
			<p>Hi {userName},</p>
			<p>你已经登录.</p>
				<div style={{
					display:'flex',
					justifyContent:'space-between',
				}}>
					{adminButton}
					<Button size="large" href={signoutPath} type="link-cancel">
						登出
					</Button>
				</div>
				
			
			
		</div>
	);
};

UserInfo.propTypes = {
	adminPath: PropTypes.string.isRequired,
	signoutPath: PropTypes.string.isRequired,
	userCanAccessKeystone: PropTypes.bool,
	userName: PropTypes.string.isRequired,
};

module.exports = UserInfo;
