import {  combineReducers } from 'redux';
import _ from 'lodash';
import store from './App/store';


function PluginReduxManager(store){
    this.pluginRoutes = [];
    this.store = store;
}
PluginReduxManager.prototype.concatRoutes = function(routes) {
    this.pluginRoutes = _.concat(this.pluginRoutes, routes);
}
PluginReduxManager.prototype.addReducers = function (reducers) {
	_.assign(this.store.reducerMap, reducers);
	var combins = combineReducers( this.store.reducerMap, reducers);
    this.store.replaceReducer(combins);

}
PluginReduxManager.prototype.getRoutes = function(){
    return this.pluginRoutes;
}
PluginReduxManager.prototype.getStore = function(){
	return this.store;
}

exports = module.exports = new PluginReduxManager(store);
