var babelify = require('babelify');
var browserify = require('browserify');
var path = require('path');
var uglify = require('uglify-to-browserify');
var basedir = path.resolve(__dirname + '/../admin/client/');
var b = browserify(process.argv[2], {
	basedir,
});
var packages = require('../admin/client/prebuild/packages');
b = b.transform(babelify);
b.exclude('FieldTypes');
b.exclude('antdlib');
packages.forEach(function (i) {
	b.exclude(i);
});
b.require(process.argv[2], {expose:process.argv[3]});
if (process.env.NODE_ENV === 'production'){
	b.bundle().pipe(uglify()).pipe(process.stdout);
} else {
	b.bundle().pipe(process.stdout);
}
