var babelify = require('babelify');
var browserify = require('browserify');
var path = require('path');
var str = require('string-to-stream');
var uglify = require('./uglifystream');
var basedir = path.resolve(__dirname + '/../admin/client/');
var b = browserify({
	basedir,
});
var packages = require('../admin/client/prebuild/packages');
b = b.transform(babelify);
b.exclude('FieldTypes');
b.exclude('antdlib');
b.exclude('KCms');
b.exclude('kadm-component');
var packages = require('../admin/client/prebuild/packages');
packages.forEach(function (i) {
	b.exclude(i);
});
b.require('./reduxManager.js', { expose: 'kadm-redux-mng' });

if (process.env.NODE_ENV === 'production'){
	uglify(b).pipe(process.stdout);
} else {
	b.bundle().pipe(process.stdout);
}
