'use strict';

var readFileSync = require('fs').readFileSync;
var Transform = require('stream').Transform;
var UglifyJS = require('uglify-js');
var _ = require('lodash');
function uglify (opts) {
  var stream = new Transform();
  stream._flush = function(callback) {
    var files = {};
    UglifyJS.FILES.forEach(function(file) {
      files[file] = readFileSync(file, 'utf8');
    });
    var opt = _.assign({},opts);
    //   console.log(opt);
    stream.push(UglifyJS.minify(files, opt).code);
    callback();
  };
  stream._transform = function(chunk, encoding, callback) {
    callback();
  };
  return stream;
};

module.exports = (b) => {
    return b.bundle().pipe(uglify({}))
}