import React from 'react';
import Field from '../Field';
import {InputNumber} from 'antdlib';

module.exports = Field.create({
	displayName: 'NumberField',
	statics: {
		type: 'Number',
	},
	getValidateRules(){
		return [{ required:this.props.required,
			message: '错误的数字格式,将会强转为数字保存', type: 'number'
		}];
	},
	renderField () {
		return (
			<InputNumber
				size='large'
				name={this.getInputName(this.props.path)}
			/>
		);
	},
});
