/**
 * Created by kinfen on 2017/5/12.
 */

var kadm = require('../')
var keystone = kadm.getAdminPlus(),
	Types = kadm.Field.Types,
	config = require('../config/config');

var AppModule = new keystone.List('AppModule', {
	track:true,
});

AppModule.add({
	name: { label:"名称", type: String, required: true, initial:true},
	module:{ label:'所属应用类型', type:Types.ModuleSelect, required: true, initial:true, innerAppsLimit:true},
	icon: { label:"图标", type: Types.AntdsIcon},
	parent: {label:"父级", type: Types.Relationship, ref: 'AppModule', treeMode:true },
	link:{ label:"链接", type: Types.Url},
	state:{label:"状态", type: Types.Select, numeric:true, options: config.global_states, default:config.GLOBAL_STATE_NORMAL.value },
	publishedDate: {label:"发布日期", type: Types.Datetime, default: Date.now }
});
AppModule.defaultColumns = 'name, state|100,  publishedDate|100';
AppModule.register();
